diff -urN kaffe-1.1.4/libraries/clib/awt/X/cbd.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/cbd.c
--- kaffe-1.1.4/libraries/clib/awt/X/cbd.c	2000-02-29 13:31:26.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/cbd.c	2004-03-12 21:25:59.000000000 +0800
@@ -38,6 +38,7 @@
 jobject
 selectionRequest ( JNIEnv* env, Toolkit* X )
 {
+#if 0	
   XEvent     e;
   char       *mime;
   jstring    jMimeType;
@@ -81,7 +82,7 @@
   e.xselection.time      = X->event.xselectionrequest.time;
 
   XSendEvent( X->dsp, e.xselection.requestor, False, 0, &e);
-
+#endif
   return 0; /* don't pass event to Java */
 }
 
@@ -97,6 +98,7 @@
 static int
 getRawData ( Toolkit* X, Atom target, unsigned char** pData )
 {
+#if 0	
   int              i, format;
   unsigned long    len = 8191, remain = 1;
   Atom             type;
@@ -119,7 +121,7 @@
 	}
 	sleep( 1);
   }
-
+#endif
   return -1; /* no selection owner at all */
 }
 
@@ -131,6 +133,7 @@
 jobject
 Java_java_awt_Toolkit_cbdInitClipboard ( JNIEnv* env, jclass clazz )
 {
+#if 0	
   unsigned long mask = 0;
   XSetWindowAttributes attrs;
 
@@ -157,7 +160,7 @@
 
   SELECTION_DATA   = XInternAtom( X->dsp, "SELECTION_DATA", False);
   JAVA_OBJECT      = XInternAtom( X->dsp, "application/x-java-serialized-object", False);
-
+#endif
   return 0;
 }
 
@@ -169,10 +172,12 @@
 jboolean
 Java_java_awt_Toolkit_cbdSetOwner ( JNIEnv* env, jclass clazz, ClipBoard* cbd )
 {
+#if 0	
   XSetSelectionOwner( X->dsp, XA_PRIMARY, X->cbdOwner, CurrentTime);
   if ( XGetSelectionOwner( X->dsp, XA_PRIMARY) != X->cbdOwner )
 	return 0;
   else
+#endif	  
 	return 1;
 }
 
diff -urN kaffe-1.1.4/libraries/clib/awt/X/clr.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/clr.c
--- kaffe-1.1.4/libraries/clib/awt/X/clr.c	2003-09-26 02:27:36.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/clr.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,6 +4,9 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
@@ -20,7 +23,7 @@
  */
 
 static inline int
-xclrEquals ( XColor* pc, int r, int g, int b )
+xclrEquals ( GdkColor* pc, int r, int g, int b )
 {
   return ((pc->red == r) && (pc->green == g) && (pc->blue == b));
 }
@@ -141,7 +144,7 @@
 
 
 static void
-fillUpColorCube ( Rgb2Pseudo* map, Colormap cm, int nAvail, unsigned long *pixels,
+fillUpColorCube ( Rgb2Pseudo* map, GdkColormap* cm, int nAvail, unsigned long *pixels,
 				  unsigned char (*mp) [8][8][8] )
 {
   int            i, j, k, pix, l;
@@ -149,7 +152,7 @@
   int            r, g, b;
   Mismatch       *mm = alloca( maxMis* sizeof( Mismatch));
   unsigned char  d;
-  XColor         xclr;
+  GdkColor       gclr;
 
   memset( *mp, 0, 8*8*8);
 
@@ -192,17 +195,16 @@
 	g = rgb8[ mm[l].j ];
 	b = rgb8[ mm[l].k ];
 
-	xclr.pixel = pixels[l];
-	xclr.flags = DoRed | DoGreen | DoBlue;
-	xclr.red   = r << 8;
-	xclr.green = g << 8;
-	xclr.blue  = b << 8;
-    XStoreColor( X->dsp, cm, &xclr);
-
-	map->pix [mm[l].i] [mm[l].j] [mm[l].k] = xclr.pixel;
-	map->rgb[xclr.pixel].r = r;
-	map->rgb[xclr.pixel].g = g;
-	map->rgb[xclr.pixel].b = b;
+	gclr.pixel = pixels[l];
+	gclr.red   = r << 8;
+	gclr.green = g << 8;
+	gclr.blue  = b << 8;
+	gdk_color_change( cm, &gclr);
+
+	map->pix [mm[l].i] [mm[l].j] [mm[l].k] = gclr.pixel;
+	map->rgb[gclr.pixel].r = r;
+	map->rgb[gclr.pixel].g = g;
+	map->rgb[gclr.pixel].b = b;
 
 	/* mark this cell as satisifed */
 	(*mp) [mm[l].i] [mm[l].j] [mm[l].k] = 0;
@@ -223,7 +225,7 @@
 #define MAX_REQUESTS 16
 
 static void
-initColormap ( JNIEnv* env, Toolkit* X, Colormap cm, Rgb2Pseudo* map )
+initColormap ( JNIEnv* env, Toolkit* X, GdkColormap* cm, Rgb2Pseudo* map )
 {
   jclass   clazz;
   jfieldID fid;
@@ -235,8 +237,8 @@
   jint     req[MAX_REQUESTS];
   unsigned long  planeMasks[1];
   int      n, i, j, k, l, m, pix;
-  Visual   *v = DefaultVisualOfScreen( DefaultScreenOfDisplay( X->dsp));
-  XColor   xclr;
+  GdkVisual *v = gdk_visual_get_system();
+  GdkColor gclr;
   int      r, g, b;
   char     blackSeen = 0;
   unsigned char (*mp)[8][8][8] = alloca( 8*8*8 * sizeof( char));
@@ -265,26 +267,25 @@
    * in even worse results
    */
   for ( n= 10; n; n-- ) {
-	if ( XAllocColorCells( X->dsp, cm, False, planeMasks, 0, pixels, n) )
+	if ( gdk_colors_alloc( cm, 0, planeMasks, 0, pixels, n) )
 	  break;
   }
 
-  xclr.red = 0; xclr.green = 0; xclr.blue = 0;
-  xclr.flags = DoRed | DoGreen | DoBlue;
+  gclr.red = 0; gclr.green = 0; gclr.blue = 0;
 
   /* mark all of our cells (so that we don't rely on their current values) */
   for ( i=0; i<n; i++ ){
-	xclr.pixel = pixels[i];
-	XStoreColor( X->dsp, cm, &xclr);
+    gclr.pixel = pixels[i];
+    gdk_color_change( cm, &gclr);
   }
 
   /* check which of our rgb requests are already in the colormap */
-  for ( l=0; l<v->map_entries; l++ ) {
-	xclr.pixel = l;
-	XQueryColor( X->dsp, cm, &xclr);
-	r = xclr.red >> 8;
-	g = xclr.green >> 8;
-	b = xclr.blue >> 8;
+  for ( l=0; l<v->colormap_size; l++ ) {
+        gclr.pixel = l;
+        //      XQueryColor( X->dsp, cm, &xclr);
+        r = gclr.red >> 8;
+        g = gclr.green >> 8;
+        b = gclr.blue >> 8;
 
 	i = JI8(r);
 	j = JI8(g);
@@ -332,16 +333,16 @@
 	  g = JGREEN( req[i]);
 	  b = JBLUE( req[i]);
 
-	  xclr.pixel = pixels[j++];
-	  xclr.red   = r << 8;
-	  xclr.green = g << 8;
-	  xclr.blue  = b << 8;
-	  XStoreColor( X->dsp, cm, &xclr);
-
-	  map->pix [JI8(r)] [JI8(g)] [JI8(b)] = xclr.pixel;
-	  map->rgb[xclr.pixel].r = r;
-	  map->rgb[xclr.pixel].g = g;
-	  map->rgb[xclr.pixel].b = b;
+          gclr.pixel = pixels[j++];
+          gclr.red   = r << 8;
+          gclr.green = g << 8;
+          gclr.blue  = b << 8;
+          gdk_color_change( cm, &gclr);
+
+          map->pix [JI8(r)] [JI8(g)] [JI8(b)] = gclr.pixel;
+          map->rgb[gclr.pixel].r = r;
+          map->rgb[gclr.pixel].g = g;
+          map->rgb[gclr.pixel].b = b;
 	}
   }
 
@@ -357,14 +358,13 @@
 static Rgb2Pseudo*
 initRgb2Pseudo ( JNIEnv* env, jclass clazz, Toolkit* X )
 {
-  Colormap dcm;
+  GdkColormap* dcm;
   int i, j, k;
-  XColor xclr;
+  GdkColor gclr;
   Rgb2Pseudo *map;
 
-  dcm = DefaultColormapOfScreen( DefaultScreenOfDisplay( X->dsp));
+  dcm = gdk_colormap_get_system();;
   map = (Rgb2Pseudo*) AWT_MALLOC( sizeof(Rgb2Pseudo));
-  xclr.flags = DoRed | DoGreen | DoBlue;
 
   for ( i=0; i<8; i++ ){
 	for ( j=0; j<8; j++ ) {
@@ -374,7 +374,6 @@
   }
 
   initColormap( env, X, dcm, map);
-  X->colorMode = CM_PSEUDO_256;
 
   return map;
 }
@@ -387,79 +386,32 @@
 static Rgb2True*
 initRgb2True (JNIEnv* env, jclass clazz,  Toolkit* X )
 {
-  Visual *v = DefaultVisualOfScreen( DefaultScreenOfDisplay( X->dsp));
-  unsigned int m;
+  GdkVisual *v = gdk_visual_get_system();
+  unsigned int n, m;
   int      nRed, nGreen, nBlue;
-  int      iRed, iGreen, iBlue;
-  int      n;
-  Rgb2True *map = 0;
-
-  if ( (v->blue_mask == 0xff) && (v->green_mask == 0xff00) && (v->red_mask == 0xff0000) ){
-	/*
-	 * This is our favourite case - a direct 8-8-8 native rgb. It could be handled as
-	 * a 0,0 TrueColor conversion, but (esp. for image manipulations) we can save a lot
-	 * of computation by a special TrueColor mode
-	 */
-	DBG( AWT_CLR, printf("AWT color mode: CM_TRUE_888\n"));
-	X->colorMode = CM_TRUE_888;
-  }
-  else {
-	/*
-	 * There is either a rearrangement or a non-8 bit color component involved,
-	 * get start index and length of each color component. Note that the Rgb2True
-	 * struct is used to compute pixelvalues from Java rgbs, i.e. the mask and shift
-	 * values are relative to the Java 8-8-8 RGB.
-	 */
-	map = (Rgb2True*) AWT_MALLOC( sizeof( Rgb2True));
-
-	for ( iBlue=0, m=v->blue_mask; (m & 1) == 0; iBlue++, m >>= 1);
-	for ( nBlue=0; m; nBlue++, m >>= 1 );
-
-	for ( iGreen=0, m=v->green_mask; (m & 1) == 0; iGreen++, m >>= 1);
-	for ( nGreen=0; m; nGreen++, m >>= 1 );
-
-	for ( iRed=0, m=v->red_mask; (m & 1) == 0; iRed++, m >>= 1);
-	for ( nRed=0; m; nRed++, m >>= 1 );
-
-	map->blueShift = 8 - (iBlue + nBlue);
-	if ( nBlue < 8 ){  /* color reduction */
-	  n = 8 - nBlue;
-	  map->blueMask = (0xff >> n) << n;
-	}
-	else {             /* color expansion */
-	  map->blueMask = 0xff;
-	}
-
-	map->greenShift = 16 - (iGreen + nGreen);
-	if ( nGreen < 8 ){ /* color reduction */
-	  n = 8 + (8 - nGreen);
-	  map->greenMask = (0xff00 >> n) << n;
-	}
-	else {             /* color expansion */
-	  map->greenMask = 0xff00;
-	}
-
-	map->redShift = 24 - (iRed + nRed);
-	if ( nRed < 8 ){  /* color reduction */
-	  n = 16 + (8 - nRed);
-	  map->redMask = (0xff0000 >> n) << n;
-	}
-	else {            /* color expansion */
-	  map->redMask = 0xff0000;
-	}
-
-	X->colorMode = CM_TRUE;
+  
+  Rgb2True *map = (Rgb2True*) AWT_MALLOC( sizeof( Rgb2True));
 
-	DBG( AWT_CLR, printf("AWT color mode: CM_TRUE\n"));
-	DBG( AWT_CLR, printf("    red:   %8x, %d\n", map->redMask, map->redShift));
-	DBG( AWT_CLR, printf("    green: %8x, %d\n", map->greenMask, map->greenShift));
-	DBG( AWT_CLR, printf("    blue:  %8x, %d\n", map->blueMask, map->blueShift));
-  }
+  for ( nBlue=0, m=v->blue_mask; m; nBlue++, m >>= 1 );
+  for ( nGreen=0, m=v->green_mask >> nBlue; m; nGreen++, m >>= 1 );
+  for ( nRed=0, m=v->red_mask >> (nBlue+nGreen); m; nRed++, m >>= 1 );
+
+  n = 8 - nBlue;
+  map->blueMask = (0xff >> n) << n;
+  map->blueShift = n;
+
+  n = 16 - nGreen;
+  map->greenMask = (0xff00 >> n) << n;
+  map->greenShift = 16 - (nBlue + nGreen);
+  
+  n = 24 - nRed;
+  map->redMask = (0xff0000 >> n) << n;
+  map->redShift = 24 - (nBlue + nGreen + nRed);
 
   return map;
 }
 
-
+#if 0
 /********************************************************************************
  * DirectColor (RGB) visual: each pixel value is composed of three, non-overlapping
  * colormap indices.
@@ -596,7 +548,7 @@
 
   return map;
 }
-
+#endif
 
 /********************************************************************************
  * common funcs
@@ -605,6 +557,7 @@
 void
 initColorMapping ( JNIEnv* env, jclass clazz,  Toolkit* X )
 {
+#if 0
   Visual *v = DefaultVisualOfScreen( DefaultScreenOfDisplay( X->dsp));
 
   DBG( AWT_CLR, printf("X visual:\n"));
@@ -632,6 +585,7 @@
   }
 
   DBG( AWT_CLR, printf("colorMode: %d\n", X->colorMode));
+#endif
 }
 
 
@@ -642,19 +596,9 @@
 jint
 Java_java_awt_Toolkit_clrGetPixelValue ( JNIEnv* env, jclass clazz, jint rgb )
 {
-  jint pix;
-
-  /*
-   * We do this deferred to avoid class init problems with Defaults<->Color
-   * (the notorious DefaultsRGB workaround)
-   */
-  if ( !X->colorMode )
-	initColorMapping( env, clazz, X);
-
-  pix = pixelValue( X, rgb);
-  DBG( AWT_CLR, printf("clrGetPixelValue: %8x -> %x (%d)\n", rgb, pix, pix));
-
-  return pix;
+  gdk_rgb_init();
+  DBG( AWT_CLR, printf("clrGetPixelValue: %8x \n", rgb));
+  return gdk_rgb_xpixel_from_rgb( rgb);
 }
 
 void
@@ -705,6 +649,7 @@
 jlong
 Java_java_awt_Toolkit_clrBright ( JNIEnv* env, jclass clazz, jint rgb )
 {
+#if 0
   unsigned int r, g, b;
   jint     modRgb, modPix;
 
@@ -724,11 +669,14 @@
   modPix = pixelValue( X, modRgb);
 
   return (((jlong)modPix << 32) | modRgb);
+#endif
+  return rgb;
 }
 
 jlong
 Java_java_awt_Toolkit_clrDark ( JNIEnv* env, jclass clazz, jint rgb )
 {
+#if 0
   unsigned int r, g, b;
   jint     modRgb, modPix;
 
@@ -744,15 +692,18 @@
   modPix = pixelValue( X, modRgb);
 
   return (((jlong)modPix << 32) | modRgb);
+#endif
+  return rgb;
 }
 
 jobject
 Java_java_awt_Toolkit_clrGetColorModel ( JNIEnv* env, jclass clazz )
 {
   jobject    cm = 0;
+#if 0
   jclass     cmClazz;
   jmethodID  cmCtorId;
-  Visual     *v = DefaultVisualOfScreen( DefaultScreenOfDisplay( X->dsp));
+  GdkVisual *v = gdk_visual_get_system();
 
   if ( !X->colorMode )
 	initColorMapping( env, clazz, X);
@@ -776,6 +727,6 @@
 	 */
 	break;
   }
-
+#endif
   return cm;
 }
diff -urN kaffe-1.1.4/libraries/clib/awt/X/evt.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/evt.c
--- kaffe-1.1.4/libraries/clib/awt/X/evt.c	2004-01-07 04:23:16.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/evt.c	2004-03-15 09:34:41.000000000 +0800
@@ -4,36 +4,26 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
 
 
-#include <X11/Xlib.h>
-#include <X11/Xutil.h>
-#include <X11/keysym.h>
 #include "toolkit.h"
 #include "keysyms.h"
 
-
-#if !defined (USE_POLLING_AWT)
-#include "jsyscall.h"
-#include "../../../../kaffe/kaffevm/locks.h"
-
 #if defined(UNIX_JTHREADS)
 void jthreadedBlockEAGAIN(int fd);   /* move to SysCallInterface ? */
 int jthreadedFileDescriptor(int fd);
 #endif
 
-#endif /* !USE_POLLING_AWT */
-
-void forwardFocus ( int cmd, Window wnd );  /* from wnd.c */
-
-
 /*******************************************************************************
  *
  */
-
+#if 0 /* Unused */
 static int nextEvent ( JNIEnv* env, jclass clazz, Toolkit *X, int blockIt )
 {
   if ( X->preFetched )
@@ -113,7 +103,7 @@
 
   return 1;
 }
-
+#endif /* Unused */
 
 /* X-to-Java key modifier mapping
  *                                     altGr   : PC
@@ -133,6 +123,181 @@
   return mod;
 }
 
+/* GTK+-related routines */
+gint button_press_callback( GtkWidget* widget, GdkEventButton* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, MouseEvent, queueMouseEvent,
+                                       X->srcIdx, (X->evtId = MOUSE_PRESSED),
+                                       evt->button, (int)evt->x, (int)evt->y);
+  } 
+  return ( TRUE);
+} 
+    
+gint button_release_callback( GtkWidget* widget, GdkEventButton* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, MouseEvent, queueMouseEvent,
+                                       X->srcIdx, (X->evtId = MOUSE_RELEASED),
+                                       evt->button, (int)evt->x, (int)evt->y);
+  }
+  return ( TRUE);
+}
+
+gint motion_notify_callback( GtkWidget* widget, GdkEventMotion* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, MouseEvent, queueMouseEvent,
+                                       X->srcIdx, (X->evtId = MOUSE_MOVED),
+                                       0, (int)evt->x, (int)evt->y);
+  }
+  return ( TRUE);
+}
+
+/*
+ * connected to delete_event ( Titlebar closing )
+ */
+gint delete_callback( GtkWidget* widget, GdkEventAny* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, WindowEvent, queueWindowEvent,
+                                       X->srcIdx, (X->evtId = WINDOW_CLOSED));
+  }
+  return ( TRUE);
+}
+
+/*
+ * connected to destroy signal ( raised by gtk_destroy_widget <- wndDestroyWindow )
+ */
+gint destroy_callback( GtkWidget* widget, GdkEventAny* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+   (*X->env)->CallStaticObjectMethod( X->env, WindowEvent, queueWindowEvent,
+                               X->srcIdx, (X->evtId = WINDOW_CLOSED));
+  }
+  return ( TRUE);
+}
+
+gint expose_callback( GtkWidget* widget, GdkEventExpose* evt, gpointer data) {
+  int x = evt->area.x;
+  int y = evt->area.y;
+  int w = evt->area.width;
+  int h = evt->area.height;
+  int count = evt->count;
+  int xw, yh, exw, eyh;
+  GdkEventExpose* ege;
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, PaintEvent, queuePaintEvent,
+                                       X->srcIdx, (X->evtId = PAINT),
+                                       x, y, w, h);
+  }
+
+  return ( TRUE);
+}
+
+gint key_press_callback( GtkWidget* widget, GdkEventKey* evt, gpointer data) {
+  int keysym = evt->keyval;
+  int mod     = evt->state;
+  int keyCode, keyChar;
+
+  if ( (keysym >= 0xff00) || (evt->length == 0) ) {
+    keyCode = FKeyCode[keysym & 0xff];
+    if ( keyCode < 0 ){
+      keyChar = keyCode = -keyCode;
+    }
+    else {
+      keyChar = 0;
+    }
+  }
+  else {
+    keyChar = (unsigned char)evt->string[0];
+    keyCode = keyChar & ~0x20;
+  }
+
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, KeyEvent, queueKeyEvent,
+                                       X->srcIdx, (X->evtId = KEY_PRESSED),
+                                       keyCode, keyChar, mod);
+    (*X->env)->CallStaticObjectMethod( X->env, KeyEvent, queueKeyEvent,
+                                       X->srcIdx, (X->evtId = KEY_RELEASED),
+                                       keyCode, keyChar, mod);
+  }
+  return ( FALSE);
+}
+
+gint key_release_callback( GtkWidget* widget, GdkEventKey* evt, gpointer data) {
+  return ( TRUE);
+}
+
+gint enter_notify_callback( GtkWidget* widget, GdkEventCrossing* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, MouseEvent, queueMouseEvent,
+                                       X->srcIdx, (X->evtId = MOUSE_ENTERED),
+                                       0, (int)evt->x, (int)evt->y);
+  }
+  return ( TRUE);
+}
+
+gint leave_notify_callback( GtkWidget* widget, GdkEventCrossing* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, MouseEvent, queueMouseEvent,
+                                       X->srcIdx, (X->evtId = MOUSE_EXITED),
+                                       0, (int)evt->x, (int)evt->y);
+  }
+  return ( TRUE);
+}
+
+gint configure_callback( GtkWidget* widget, GdkEventConfigure* evt, gpointer data) {
+  int x = evt->x;
+  int y = evt->y;
+  int w = evt->width;
+  int h = evt->height;
+
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, ComponentEvent, queueComponentEvent,
+                                       X->srcIdx, (X->evtId = COMPONENT_RESIZED),
+                                       x, y, w, h);
+  }
+  return ( TRUE);
+}
+
+gint focus_in_callback( GtkWidget* widget, GdkEventFocus* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, FocusEvent, queueFocusEvent,
+                                       X->srcIdx, (X->evtId = FOCUS_GAINED));
+  }
+  return ( TRUE);
+}
+
+gint focus_out_callback( GtkWidget* widget, GdkEventFocus* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, FocusEvent, queueFocusEvent,
+                                       X->srcIdx, (X->evtId = FOCUS_LOST));
+  }
+  return ( TRUE);
+}
+
+gint map_callback( GtkWidget* widget, GdkEventAny* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, WindowEvent, queueWindowEvent,
+                                       X->srcIdx, (X->evtId = WINDOW_DEICONIFIED) );
+  }
+  return ( TRUE);
+}
+
+gint unmap_callback( GtkWidget* widget, GdkEventAny* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+    (*X->env)->CallStaticObjectMethod( X->env, WindowEvent, queueWindowEvent,
+                                       X->srcIdx, (X->evtId = WINDOW_ICONIFIED) );
+  }
+  return ( TRUE);
+}
+
+gint visibility_notify_callback( GtkWidget* widget, GdkEventVisibility* evt, gpointer data) {
+  return ( TRUE);
+}
+
+gint client_callback( GtkWidget* widget, GdkEventClient* evt, gpointer data) {
+  if ( getWidgetIdx( widget, (GdkEvent*)evt ) > -1 ) {
+  }
+  return ( TRUE);
+}
+
 
 jclass     AWTEvent;
 jclass     ComponentEvent;
@@ -151,28 +316,7 @@
 jmethodID  getPaintEvent;
 jmethodID  getWMEvent;
 
-#define    COMPONENT_RESIZED    101
-
-#define    WINDOW_CLOSING       201
-#define    WINDOW_CLOSED        202
-#define    WINDOW_ICONIFIED     203
-#define    WINDOW_DEICONIFIED   204
-
-#define    KEY_PRESSED          401
-#define    KEY_RELEASED         402
-
-#define    MOUSE_PRESSED        501
-#define    MOUSE_RELEASED       502
-#define    MOUSE_MOVED          503
-#define    MOUSE_ENTERED        504
-#define    MOUSE_EXITED         505
-
-#define    PAINT                800
 #define    UPDATE               801
-
-#define    FOCUS_GAINED        1004
-#define    FOCUS_LOST          1005
-
 #define    WM_KILLED           1905
 
 #if defined(KAFFE_VMDEBUG) && !defined(NDEBUG)
@@ -208,6 +352,7 @@
 };
 #endif /* defined(KAFFE_VMDEBUG) && !defined(NDEBUG) */
 
+#if 0 /* Unused */
 static jobject
 skip ( JNIEnv* env, Toolkit* X )
 {
@@ -743,7 +888,7 @@
   clientMessage,        /* ClientMessage           33 */
   skip                  /* MappingNotify           34 */
 };
-
+#endif /* Unused */
 
 /*******************************************************************************
  *
@@ -753,74 +898,39 @@
 Java_java_awt_Toolkit_evtInit ( JNIEnv* env, jclass clazz )
 {
   jclass Component;
-#if !defined(USE_POLLING_AWT)
-  unsigned long mask;
-  XSetWindowAttributes attrs;
-#endif
+ 
+  DBG( AWT_EVT, printf("evtInit..\n")); 
+  ComponentEvent = (*env)->FindClass( env, "java.awt.event.ComponentEvent");
+  MouseEvent     = (*env)->FindClass( env, "java.awt.event.MouseEvent");
+  FocusEvent     = (*env)->FindClass( env, "java.awt.event.FocusEvent");
+  WindowEvent    = (*env)->FindClass( env, "java.awt.event.WindowEvent");
+  KeyEvent       = (*env)->FindClass( env, "java.awt.event.KeyEvent");
+  PaintEvent     = (*env)->FindClass( env, "java.awt.event.PaintEvent");
+  ActionEvent    = (*env)->FindClass( env, "java.awt.event.ActionEvent");
+  ItemEvent      = (*env)->FindClass( env, "java.awt.event.ItemEvent");
+
+  queueComponentEvent = (*env)->GetStaticMethodID( env, ComponentEvent, 
+ 	                                           "getEvent", "(IIIIII)Ljava/awt/ComponentEvt;");
+  queueMouseEvent     = (*env)->GetStaticMethodID( env, MouseEvent,
+                                                   "getEvent", "(IIIII)Ljava/awt/MouseEvt;");
+  queueFocusEvent     = (*env)->GetStaticMethodID( env, FocusEvent,
+                                                   "getEvent", "(IIZ)Ljava/awt/FocusEvt;"); 
+  queueWindowEvent    = (*env)->GetStaticMethodID( env, WindowEvent,
+                                                   "getEvent", "(II)Ljava/awt/WindowEvt;");
+  queueKeyEvent       = (*env)->GetStaticMethodID( env, KeyEvent,
+                                                   "getEvent", "(IIIII)Ljava/awt/KeyEvt;");
+  queuePaintEvent     = (*env)->GetStaticMethodID( env, PaintEvent, 
+                                                   "getEvent", "(IIIIII)Ljava/awt/PaintEvt;");  
+  queueActionEvent    = (*env)->GetStaticMethodID( env, ActionEvent,
+                                                   "getEvent", "(IIIIII)Ljava/awt/ActionEvt;"); 
+  queueItemEvent      = (*env)->GetStaticMethodID( env, ItemEvent, 
+                                                   "getEvent", "(IIIIII)Ljava/awt/ItemEvt;");
 
-  if ( ComponentEvent != NULL ){
-	DBG( AWT_EVT, printf("evtInit called twice\n"));
-	return NULL;
-  }
-
-  ComponentEvent = (*env)->FindClass( env, "java/awt/ComponentEvt");
-  assert(ComponentEvent != NULL);
-  MouseEvent     = (*env)->FindClass( env, "java/awt/MouseEvt");
-  assert(MouseEvent != NULL);
-  FocusEvent     = (*env)->FindClass( env, "java/awt/FocusEvt");
-  assert(FocusEvent != NULL);
-  WindowEvent    = (*env)->FindClass( env, "java/awt/WindowEvt");
-  assert(WindowEvent != NULL);  
-  KeyEvent       = (*env)->FindClass( env, "java/awt/KeyEvt");
-  assert(KeyEvent != NULL);
-  PaintEvent     = (*env)->FindClass( env, "java/awt/PaintEvt");
-  assert(PaintEvent != NULL);
-  WMEvent        = (*env)->FindClass( env, "java/awt/WMEvent");
-  assert(WMEvent != NULL);
-
-  getComponentEvent = (*env)->GetStaticMethodID( env, ComponentEvent, "getEvent", 
-												 "(IIIIII)Ljava/awt/ComponentEvt;");
-  getMouseEvent     = (*env)->GetStaticMethodID( env, MouseEvent, "getEvent",
-												 "(IIIII)Ljava/awt/MouseEvt;");
-  getFocusEvent     = (*env)->GetStaticMethodID( env, FocusEvent, "getEvent",
-												 "(IIZ)Ljava/awt/FocusEvt;");
-  getWindowEvent    = (*env)->GetStaticMethodID( env, WindowEvent, "getEvent",
-												 "(II)Ljava/awt/WindowEvt;");
-  getKeyEvent       = (*env)->GetStaticMethodID( env, KeyEvent, "getEvent",
-												 "(IIIII)Ljava/awt/KeyEvt;");
-  getPaintEvent     = (*env)->GetStaticMethodID( env, PaintEvent, "getEvent",
-												 "(IIIIII)Ljava/awt/PaintEvt;");
-  getWMEvent        = (*env)->GetStaticMethodID( env, WMEvent, "getEvent",
-												 "(II)Ljava/awt/WMEvent;");
-
-#if !defined(USE_POLLING_AWT)
-  /*
-   * we need a target for evtWakeup(), which is used to unblock nextEvent() in
-   * case we post a event to the localqueue
-   */
-  mask = CWEventMask;
-  attrs.override_redirect = True;
-  attrs.event_mask = StructureNotifyMask;
+  X->nWindows = 300;
+  X->windows = (Widget**)calloc( X->nWindows, sizeof(Widget*));
 
-  X->wakeUp = XCreateWindow( X->dsp, X->root, -1000, -1000, 1, 1, 0, CopyFromParent,
-							   InputOutput, CopyFromParent, mask, &attrs);
+  Component = (*env)->FindClass( env, "java.awt.Component");
 
-  /*
-   * make X connection non-blocking (to get SIGIOs)
-   * NOTE: this requires all Xlib calls doing IO via the X conn to be synced! In addition,
-   * no Xlib function doing blocked reads on the connection should be called without
-   * ensuring that there is input available.
-   */
-#if defined (UNIX_JTHREADS)
-  jthreadedFileDescriptor( ConnectionNumber(X->dsp));
-#elif defined (UNIX_PTHREADS)
-  FD_ZERO( &X->rfds);
-  FD_SET( ConnectionNumber(X->dsp), &X->rfds);
-#endif
-
-#endif /* !USE_POLLING_AWT */
-
-  Component = (*env)->FindClass( env, "java/awt/Component");
   return (*env)->NewObjectArray( env, X->nWindows, Component, NULL);
 }
 
@@ -829,10 +939,10 @@
 Java_java_awt_Toolkit_evtGetNextEvent ( JNIEnv* env, jclass clazz )
 {
   jobject jEvt = NULL;
-
+#if 0
   DBG( AWT_EVT, printf("getNextEvent..\n"));
 
-  while ( nextEvent( env, clazz, X, True) &&
+  while ( nextEvent( env, clazz, X, TRUE) &&
 		  ((getSourceIdx( X, X->event.xany.window) >= 0) || 
 		   (X->event.xany.window == X->cbdOwner)) ) {
 	X->preFetched = 0;
@@ -843,7 +953,7 @@
 
   DBG( AWT_EVT, printf("..getNextEvent: %d (%s) %d, %p, %lx\n",
 				 X->evtId, eventStr( X->evtId), X->srcIdx, jEvt, X->event.xany.window));
-
+#endif
   return jEvt;
 }
 
@@ -851,15 +961,16 @@
 Java_java_awt_Toolkit_evtPeekEvent ( JNIEnv* env, jclass clazz )
 {
   jobject jEvt = NULL;
-
+#if 0
   DBG( AWT_EVT, printf("peekEvent..\n"));
 
-  if ( nextEvent( env, clazz, X, False) && ((getSourceIdx( X, X->event.xany.window) >= 0)) ) {
+  if ( nextEvent( env, clazz, X, FALSE) && ((getSourceIdx( X, X->event.xany.window) >= 0)) ) {
 	if ( (jEvt = (processEvent[X->event.xany.type])( env, X)) )
 	  X->preFetched = 1;
   }
 
   DBG( AWT_EVT, printf("..peekEvent: %s %p, %lx\n", eventStr(X->evtId), jEvt, X->event.xany.window));
+#endif  
   return jEvt;
 }
 
@@ -871,12 +982,13 @@
 jobject
 Java_java_awt_Toolkit_evtPeekEventId ( JNIEnv* env, jclass clazz, jint id )
 {
+#if 0	
   jobject jEvt;
 
   if ( (jEvt = Java_java_awt_Toolkit_evtPeekEvent( env, clazz)) && (X->evtId == id) ){
 	return jEvt;
   }
-
+#endif
   return NULL;
 }
 
@@ -895,20 +1007,12 @@
 void
 Java_java_awt_Toolkit_evtWakeup ( JNIEnv* env, jclass clazz )
 {
-  XEvent event;
+  GdkEventClient event;
 
   DBG( AWT_EVT, printf("evtWakeup\n"));
-  DBG_ACTION( awt, XSynchronize( X->dsp, False));
-
-  event.xclient.type = ClientMessage; 
-  event.xclient.message_type = WAKEUP;
-  event.xclient.format = 8;
-  event.xclient.window = X->wakeUp;
-
-  XSendEvent( X->dsp, X->wakeUp, False, 0, &event);
-  XFlush( X->dsp);
-
-  DBG_ACTION( awt, XSynchronize( X->dsp, True));
+  event.message_type = WAKEUP;
+  event.data_format = 8;
+  gdk_event_send_clientmessage_toall( (GdkEvent*)&event);
 }
 
 /*
@@ -923,34 +1027,36 @@
 
 
 jint
-Java_java_awt_Toolkit_evtRegisterSource ( JNIEnv* env, jclass clazz, Window wnd )
+Java_java_awt_Toolkit_evtRegisterSource ( JNIEnv* env, jclass clazz, void* wnd )
 {
+  register i;
+  int      n;
+
   /*
-   * We have done that already during the various wndCreateXX()
+   * we don't use a double hashing here because collisions are very unlikely
+   * (window IDs usually already are hashed, so it does not make sense to
+   * hash them again - we just could make it worse
    */
-  int i = getSourceIdx( X, wnd);
-
-  DBG( AWT_EVT, printf("registerSource( %lx) -> %d\n", wnd, i));
-
-  return i;
+  for ( i = (unsigned long)wnd, n=0; n < X->nWindows; i++, n++ ) {
+    i %= X->nWindows;
+    DBG( AWT_EVT, printf("registerSource() -> %d\n", i));
+    if ( X->windows[i] == NULL ) {
+      X->windows[i] = (Widget*)wnd;
+      return i;
+    }
+  }
+  fprintf( stderr, "window table out of space: %d", X->nWindows);
+  return -1;
 }
 
 
 jint
-Java_java_awt_Toolkit_evtUnregisterSource ( JNIEnv* env, jclass clazz, Window wnd )
+Java_java_awt_Toolkit_evtUnregisterSource ( JNIEnv* env, jclass clazz, void* wnd )
 {
   int i = getSourceIdx( X, wnd);
 
-  if ( i >= 0 ){
-	X->windows[i].w = -1;
-	X->windows[i].flags = 0;
-	X->windows[i].owner = 0;
-  }
-
-  if ( X->lastWindow == wnd )
-	X->lastWindow = 0;
-
-  DBG( AWT_EVT, printf("unregisterSource( %lx) -> %d\n", wnd, i));
-
+  DBG( AWT_EVT, printf("unregisterSource() -> %d\n", i));
+  if ( i >= 0 )
+    X->windows[i] = NULL;
   return i;
 }
diff -urN kaffe-1.1.4/libraries/clib/awt/X/fnt.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/fnt.c
--- kaffe-1.1.4/libraries/clib/awt/X/fnt.c	2003-09-26 01:26:16.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/fnt.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,11 +4,15 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
 
-
+#include <X11/Xlib.h>
+#include <gdk/gdkx.h>
 #include "toolkit.h"
 
 /*******************************************************************************
@@ -19,8 +23,9 @@
  * this is our ultima ratio in case everything else fails, at least this
  * one should be on every X fontlist
  */
-char* backupFont = "fixed";
+char backupFont[] = "-adobe-courier-medium-r-normal--*-120-*";
 
+#if 0
 /*
  * these are (hopefully) the most usual XFLD font weight names, ordered
  * in our preferred lookup sequence (from PLAIN to BOLD)
@@ -63,6 +68,7 @@
  * that's in java.awt.Defaults, and Defaults is meant to be the thing which
  * adapts the AWT to your X installation/preferences. Don't lament, modify it!
  */
+#endif
 
 void*
 Java_java_awt_Toolkit_fntInitFont ( JNIEnv* env, jclass clazz, jstring jSpec,
@@ -71,53 +77,38 @@
   int  i, j, k, i0, i1, j0, j1, di, dj;
   char buf[160];
   char *spec = java2CString( env, X, jSpec);
-  XFontStruct* fs = 0;
-
-	size *= 10;  /* convert into X pointsizes */
-
-  if ( style & 0x1 ) { /* we have a Font.BOLD request */
-    i0 = NWEIGHT - 1; i1 = -1; di = -1;
-  }
-  else {
-    i0 = 0; i1 = NWEIGHT; di = 1;
+  char  sizedFontset[500], temp[500], *token;
+  GdkFont* fs;
+  gchar *gfontset;
+
+  if (spec == NULL)
+    return;
+
+  /* Replace %d in fontset with size of font. */
+  strcpy(temp, spec);
+  memset(sizedFontset, '\0', sizeof(sizedFontset));
+
+  token = strtok(temp, ",");
+
+  while (token != NULL) {
+    sprintf(sizedFontset + strlen(sizedFontset), token, (int)(size * 10));
+    strcat(sizedFontset, ",");
+    token = strtok(NULL, ",");
   }
 
-  if ( style & 0x2 ) { /* we have a Font.ITALIC request */
-    j0 = NSLANT - 1; j1 = -1; dj = -1;
-  }
-  else {
-    j0 = 0; j1 = NSLANT; dj = 1;
-  }
-
-  for ( j=j0; !fs && (j != j1); j += dj ) {
-    for ( i=i0; !fs && (i != i1); i += di ) {
-      for ( k=0;  !fs && (k < NDSIZE); k++ ) {
-        sprintf( buf, spec, weight[i], slant[j], size + dsize[k]);
-        DBG( AWT_FNT, printf("look up font: %s\n", buf));
-        fs = XLoadQueryFont( X->dsp, buf);
-      }
+  if ((fs = gdk_fontset_load(sizedFontset)) == NULL) {
+    fprintf( stderr, "cannot load font: %s (backup to %s)\n", sizedFontset, backupFont);
+    if (! (fs = gdk_fontset_load( backupFont)) ) {
+      fprintf( stderr, "font panic, no default font!\n");
     }
   }
-
-  if ( ! fs ){
-    /* now we are getting desperate, try the spec directly (without vars) */
-    fs = XLoadQueryFont( X->dsp, spec);
-  }
-
-  if ( ! fs ){
-	DBG( AWT, printf("cannot load font: %s (backup to %s)\n", buf, backupFont));
-	if ( !(fs = XLoadQueryFont( X->dsp, backupFont)) ) {
-	  fprintf( stderr, "font panic, no default font!\n");
-	}
-  }
-
-  return (void*) fs;
+  return (void*) fs;    
 }
 
 void
-Java_java_awt_Toolkit_fntFreeFont ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntFreeFont ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  XFreeFont( X->dsp, fs);
+  gdk_font_unref(fs);
 }
 
 
@@ -132,86 +123,92 @@
 }
 
 void
-Java_java_awt_Toolkit_fntFreeFontMetrics ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntFreeFontMetrics ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
 }
 
 
 jint
-Java_java_awt_Toolkit_fntGetAscent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetAscent ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
   return fs->ascent;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetDescent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetDescent ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
   return fs->descent;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetFixedWidth ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetFixedWidth ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  return (fs->min_bounds.width == fs->max_bounds.width) ? fs->max_bounds.width : 0;
+  XFontStruct* xfs = GDK_FONT_XFONT(fs);
+  return (xfs->min_bounds.width == xfs->max_bounds.width) ? xfs->max_bounds.width : 0;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetHeight ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetHeight ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  return fs->ascent + fs->descent +1;
+  return fs->ascent + fs->descent;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetLeading ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetLeading ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
   return 0;  /* no leading (interline spacing) for X fonts */
 }
 
 jint
-Java_java_awt_Toolkit_fntGetMaxAdvance ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetMaxAdvance ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  return fs->max_bounds.width;
+  XFontStruct* xfs = GDK_FONT_XFONT(fs);
+  return xfs->max_bounds.width;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetMaxAscent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetMaxAscent ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  return fs->max_bounds.ascent;
+  XFontStruct* xfs = GDK_FONT_XFONT(fs);
+  return xfs->max_bounds.ascent;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetMaxDescent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetMaxDescent ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  return fs->max_bounds.descent;
+  XFontStruct* xfs = GDK_FONT_XFONT(fs);
+  return xfs->max_bounds.descent;
 }
 
 jboolean
-Java_java_awt_Toolkit_fntIsWideFont ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntIsWideFont ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
-  return (fs->min_byte1 | fs->max_byte1);
+  XFontStruct* xfs = GDK_FONT_XFONT(fs);
+  return (xfs->min_byte1 | xfs->max_byte1);
 }
 
 jobject
-Java_java_awt_Toolkit_fntGetWidths ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetWidths ( JNIEnv* env, jclass clazz, GdkFont* fs )
 {
   int       n = 256;
   jintArray widths;
   jint      *jw;
   jboolean isCopy;
   register  int i, j;
+  XFontStruct* xfs = GDK_FONT_XFONT(fs);
 
   widths = (*env)->NewIntArray( env, 256);
   jw = (*env)->GetIntArrayElements( env, widths, &isCopy);
 
-  if ( fs->max_char_or_byte2 < n ) n = fs->max_char_or_byte2;
+  if ( xfs->max_char_or_byte2 < n ) n = xfs->max_char_or_byte2;
 
-  if ( fs->min_bounds.width == fs->max_bounds.width ) {
-	for ( i=fs->min_char_or_byte2, j=0; i < n; i++, j++ )
-	  jw[i] = fs->max_bounds.width;
+  if ( xfs->min_bounds.width == xfs->max_bounds.width ) {
+	for ( i=xfs->min_char_or_byte2, j=0; i < n; i++, j++ )
+	  jw[i] = xfs->max_bounds.width;
   }
   else {
-	for ( i=fs->min_char_or_byte2, j=0; i < n; i++, j++ )
-	  jw[i] = fs->per_char[j].width;
+	for ( i=xfs->min_char_or_byte2, j=0; i < n; i++, j++ )
+	  jw[i] = xfs->per_char[j].width;
   }
 
   (*env)->ReleaseIntArrayElements( env, widths, jw, 0);
@@ -221,8 +218,8 @@
 
 
 jint
-Java_java_awt_Toolkit_fntBytesWidth ( JNIEnv* env, jclass clazz,
-	XFontStruct* fs, jbyteArray jBytes, jint off, jint len )
+Java_java_awt_Toolkit_fntBytesWidth ( JNIEnv* env, jclass clazz, GdkFont* fs, 
+                                      jbyteArray jBytes, jint off, jint len )
 {
   jboolean  isCopy;
   jbyte    *jb = (*env)->GetByteArrayElements( env, jBytes, &isCopy);
@@ -231,20 +228,18 @@
 
   if ( off+len > n ) len = n - off;
 
-  w = XTextWidth( fs, jb+off, len);
-
+  w = (jint)gdk_text_width(fs, (gchar*) jb+off, len);
   (*env)->ReleaseByteArrayElements( env, jBytes, jb, JNI_ABORT);
   return w;
 }
 
 jint
-Java_java_awt_Toolkit_fntCharWidth ( JNIEnv* env, jclass clazz, XFontStruct* fs, jchar jChar )
+Java_java_awt_Toolkit_fntCharWidth ( JNIEnv* env, jclass clazz, GdkFont* fs, jchar jChar )
 {
 #ifndef WORDS_BIGENDIAN
   jChar = (jChar << 8) | (jChar >> 8);
 #endif
-
-  return XTextWidth16( fs, (XChar2b*)&jChar, 1);
+  return gdk_char_width(fs, (gchar)jChar);
 }
 
 jint
@@ -254,46 +249,25 @@
   jboolean  isCopy;
   jchar    *jc = (*env)->GetCharArrayElements( env, jChars, &isCopy);
   int      n = (*env)->GetArrayLength( env, jChars);
-  XChar2b  *b;
   int      w;
 
   if ( off+len > n ) len = n - off;
 
-#ifndef WORDS_BIGENDIAN
-  n = sizeof(XChar2b)*len;
-  b = (XChar2b*) getBuffer( X, n);
-  swab( (jc+off), b, n);
-#else
-  b = (XChar2b*) (jc + off);
-#endif
-
-  w = XTextWidth16( fs, b, len);
-
+  w = (jint)gdk_text_width(fs, (gchar*) jc, len);
+  
   (*env)->ReleaseCharArrayElements( env, jChars, jc, JNI_ABORT);
   return w;
 }
 
 jint
-Java_java_awt_Toolkit_fntStringWidth ( JNIEnv* env, jclass clazz, XFontStruct* fs, jstring jStr )
+Java_java_awt_Toolkit_fntStringWidth ( JNIEnv* env, jclass clazz, GdkFont* fs, jstring jStr )
 {
   jboolean isCopy;
   const jchar    *jc = (*env)->GetStringChars( env, jStr, &isCopy);
   int      len = (*env)->GetStringLength( env, jStr);
   int      w;
-#ifndef WORDS_BIGENDIAN
-  int      n;
-#endif
-  XChar2b  *b;
-
-#ifndef WORDS_BIGENDIAN
-  n = sizeof(XChar2b)*len;
-  b = (XChar2b*) getBuffer( X, n);
-  swab( jc, b, n);
-#else
-  b = (XChar2b*) jc;
-#endif
-
-  w = XTextWidth16( fs, b, len);
+  
+  w = (jint)gdk_text_width(fs, (gchar*) jc, len);
 
   (*env)->ReleaseStringChars( env, jStr, jc);
   return w;
diff -urN kaffe-1.1.4/libraries/clib/awt/X/gra.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/gra.c
--- kaffe-1.1.4/libraries/clib/awt/X/gra.c	2003-09-26 01:26:16.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/gra.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,21 +4,26 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
 
 #include "toolkit.h"
+#include <gdk/gdkprivate.h>
 
 typedef struct {
-  GC        gc;
-  Drawable  drw;
-  int       fg;
-  int       bg;
-  char      xor;
-  int       xclr;
-  int       x0;
-  int       y0;
+  GdkGC*        gc;
+  GdkDrawable*  drw;
+  int           fg;
+  int           bg;
+  GdkFont*      fnt;
+  char          _xor;
+  int           xclr;
+  int           x0;
+  int           y0;	
 } Graphics;
 
 #define  WINDOW   0
@@ -37,64 +42,67 @@
 										jint xClip, jint yClip, jint wClip, jint hClip,
 										jobject fnt, jint fg, jint bg, jboolean blank )
 {
-  Drawable       drw;
-  XGCValues      values;
-  XRectangle     rect;
-  unsigned long  valueMask = GCForeground | GCBackground | GCFont | GCFunction;
-
-  DBG( AWT_GRA, printf("initGraphics: %p (%p, %d) %d,%d  %d,%d - %d,%d  %p %x %x\n",
-				 gr, tgt,tgtType, xOff,yOff, xClip,yClip,wClip,hClip, fnt,fg,bg));
+  DBG( AWT_GRA, printf("initGraphics: (%p, %d) %d,%d  %d,%d - %d,%d  %p %x %x\n",
+				 tgt,tgtType, xOff,yOff, xClip,yClip,wClip,hClip, fnt,fg,bg));
+  GdkDrawable*   drw;
+  GdkGCValues    values;
+  GdkRectangle   rect;
+  GdkColor       c;
+  GdkColormap*   map = gdk_colormap_get_system();
+  unsigned long  valueMask = GDK_GC_FOREGROUND | GDK_GC_BACKGROUND | GDK_GC_FUNCTION | GDK_GC_FONT;
 
   if ( tgt ) {
-	switch ( tgtType ) {
-	case 0:  drw = (Drawable)tgt; break;          /* Window   */
-	case 1:  drw = ((Image*)tgt)->pix; break;     /* Image    */
-	case 2:  drw = ((Graphics*)tgt)->drw; break;  /* Graphics */
-	default: fprintf( stderr, "illegal Graphics target: %d\n", tgtType);
-		 drw = 0;
-	}
+        switch ( tgtType ) {
+        case 0:  drw = ((Widget*)tgt)->wnd; break;          /* Window   */
+        case 1:  drw = ((Image*)tgt)->pix; break;     /* Image    */
+        case 2:  drw = ((Graphics*)tgt)->drw; break;  /* Graphics */
+        default: fprintf( stderr, "illegal Graphics target: %d\n", tgtType);
+                 drw = 0;
+        }
   }
   else {
-	if ( gr )
-	  drw = gr->drw;
-	else {
-	  fprintf( stderr, "attempt to set an uninitialized graphics");
-	  drw = 0;
-	}
+        if ( gr )
+          drw = gr->drw;
+        else {
+          fprintf( stderr, "attempt to set an uninitialized graphics");
+          drw = 0;
+        }
   }
 
-  values.foreground = fg;
-  values.background = bg;
-  values.font       = ((XFontStruct*)fnt)->fid;
-  values.function   = GXcopy;
-  
+  values.foreground.pixel = fg;
+  values.background.pixel = bg;
+  values.font             = (GdkFont*)fnt;
+  values.function         = GDK_COPY;
+
   if ( gr ) {
-	XChangeGC( X->dsp, gr->gc, valueMask, &values);
+    gdk_gc_set_foreground( gr->gc, &values.foreground);
+    gdk_gc_set_background( gr->gc, &values.background);
+    gdk_gc_set_font( gr->gc, values.font);
+    gdk_gc_set_function( gr->gc, GDK_COPY);
   }
   else {
-	gr = (Graphics*) AWT_MALLOC( sizeof(Graphics));
-	gr->gc = XCreateGC( X->dsp, drw, valueMask, &values);
-
-	DBG( AWT_GRA, printf(" ->gr: %p (%p)\n", gr, gr->gc));
+        gr = (Graphics*) malloc( sizeof(Graphics));
+        gr->gc = gdk_gc_new_with_values( drw, &values, valueMask);
   }
 
-  rect.x      = xClip; 
+  rect.x      = xClip;
   rect.y      = yClip;
   rect.width  = (wClip > 0) ? wClip : 0;
   rect.height = (hClip > 0) ? hClip : 0;
-  XSetClipRectangles( X->dsp, gr->gc, xOff, yOff, &rect, 1, Unsorted);
+  gdk_gc_set_clip_origin( gr->gc, xOff, yOff );
+  gdk_gc_set_clip_rectangle( gr->gc, &rect);
 
   gr->fg   = fg;
   gr->bg   = bg;
   gr->drw  = drw;
   gr->x0   = xOff;
   gr->y0   = yOff;
-  gr->xor  = 0;
+  gr->_xor  = 0;
 
   if ( blank ) {
-	XSetForeground( X->dsp, gr->gc, gr->bg);
-	XFillRectangle( X->dsp, gr->drw, gr->gc, xOff+xClip, yOff+yClip, wClip, hClip);
-	XSetForeground( X->dsp, gr->gc, gr->fg);	
+        gdk_gc_set_foreground( gr->gc, &values.background);
+        gdk_draw_rectangle( gr->drw, gr->gc, 1, xOff+xClip, yOff+yClip, wClip, hClip);
+        gdk_gc_set_foreground( gr->gc, &values.foreground);
   }
 
   return gr;
@@ -104,9 +112,8 @@
 void
 Java_java_awt_Toolkit_graFreeGraphics ( JNIEnv* env, jclass clazz, Graphics* gr )
 {
-  DBG( AWT_GRA, printf("freeGraphics: %p\n", gr));
-
-  XFreeGC( X->dsp, gr->gc);
+  DBG( AWT_GRA, printf("freeGraphics\n"));
+  gdk_gc_destroy( gr->gc);
   AWT_FREE( gr);
 }
 
@@ -116,15 +123,9 @@
 									jint x, jint y, jint width, jint height,
 									jint xDelta, jint yDelta )
 {
-  DBG( AWT_GRA, printf("copyArea: %p, %d,%d-%d,%d  %d,%d\n", gr, x,y,width,height, xDelta,yDelta));
-
-  /* some X servers act alleric on that (careless bitblt, again) */
-  if ( (width < 0) || (height < 0) )
-	return;
-
+  DBG( AWT_GRA, printf("copyArea: %d,%d-%d,%d  %d,%d\n", x,y,width,height, xDelta,yDelta));
   x += gr->x0; y += gr->y0;
-  XCopyArea( X->dsp, gr->drw, gr->drw, gr->gc, x, y, width, height, x + xDelta, y + yDelta);
-  XFLUSH( X, False);
+  gdk_window_copy_area( gr->drw, gr->gc, x + xDelta, y + yDelta, gr->drw, x, y, width, height );
 }
 
 
@@ -132,12 +133,11 @@
 Java_java_awt_Toolkit_graClearRect ( JNIEnv* env, jclass clazz, Graphics* gr,
 									 jint x, jint y, jint width, jint height )
 {
-  DBG( AWT_GRA, printf("clearRect: %p, %d,%d-%d,%d\n", gr, x,y,width,height));
-
-  XSetForeground( X->dsp, gr->gc, gr->bg);
-  XFillRectangle( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height);
-  XSetForeground( X->dsp, gr->gc, gr->fg);
-  XFLUSH( X, False);
+  DBG( AWT_GRA, printf("clearRect: %d,%d-%d,%d\n", x,y,width,height));
+  GdkColor c;
+  gdk_gc_set_foreground( gr->gc, getColor(gr->bg,&c));
+  gdk_draw_rectangle( gr->drw, gr->gc, 1, x+gr->x0, y+gr->y0, width, height);
+  gdk_gc_set_foreground( gr->gc, getColor(gr->fg,&c)); 
 }
 
 
@@ -147,24 +147,21 @@
 {
   jboolean isCopy;
   int      n;
-  jbyte    *jb, *jbo;
+  jbyte    *jb;
 
   if ( !jBytes ) return;
 
   n = (*env)->GetArrayLength( env, jBytes);
   jb = (*env)->GetByteArrayElements( env, jBytes, &isCopy);
-  jbo = jb + offset;
 
-  DBG( AWT_GRA, printf("drawBytes: %p, %p,%d,%d  \"%s\"  %d,%d\n", gr,
+  DBG( AWT_GRA, printf("drawBytes: %p,%d,%d  \"%s\"  %d,%d\n", 
 				 jBytes,offset,len, jb, x,y));
 
   if ( offset+len > n )
 	len = n - offset;
 
-  XDrawString( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, jbo, len);
-
+  gdk_draw_text( gr->drw, gr->fnt, gr->gc, x+gr->x0, y+gr->y0, (jb+offset), len);
   (*env)->ReleaseByteArrayElements( env, jBytes, jb, JNI_ABORT);
-  XFLUSH( X, False);
 }
 
 
@@ -172,6 +169,7 @@
 Java_java_awt_Toolkit_graDrawChars ( JNIEnv* env, jclass clazz,
 	Graphics* gr, jcharArray jChars, jint offset, jint len, jint x, jint y )
 {
+#if 0	
   jboolean isCopy;
   int      n;
   jchar    *jc, *jco;
@@ -201,6 +199,7 @@
 
   (*env)->ReleaseCharArrayElements( env, jChars, jc, JNI_ABORT);
   XFLUSH( X, False);
+#endif  
 }
 
 
@@ -208,6 +207,7 @@
 Java_java_awt_Toolkit_graDrawString ( JNIEnv* env, jclass clazz,
 									  Graphics* gr, jstring str, jint x, jint y )
 {
+#if 0	
   jboolean     isCopy;
   int          len;
 #ifndef WORDS_BIGENDIAN
@@ -235,6 +235,7 @@
 
   (*env)->ReleaseStringChars( env, str, jc);
   XFLUSH( X, False);
+#endif  
 }
 
 
@@ -242,15 +243,8 @@
 Java_java_awt_Toolkit_graDrawLine ( JNIEnv* env, jclass clazz, Graphics* gr,
 									jint x1, jint y1, jint x2, jint y2 )
 {
-  DBG( AWT_GRA, printf("drawLine: %p, %d,%d - %d,%d\n", gr, x1,y1, x2,y2));
-
-  if ( (x1==x2) && (y1==y2) ) {  /* swing gimmick */
-	XDrawPoint( X->dsp, gr->drw, gr->gc, x1 +gr->x0, y1 +gr->y0);
-  }
-  else {
-	XDrawLine( X->dsp, gr->drw, gr->gc, x1 + gr->x0, y1 + gr->y0, x2 + gr->x0, y2 + gr->y0);
-  }
-  XFLUSH( X, False);
+  DBG( AWT_GRA, printf("drawLine: %d,%d - %d,%d\n", x1,y1, x2,y2));
+  gdk_draw_line( gr->drw, gr->gc, x1+gr->x0, y1+gr->y0, x2+gr->x0, y2+gr->y0);
 }
 
 
@@ -259,12 +253,9 @@
 								   jint x, jint y, jint width, jint height,
 								   jint startAngle, jint arcAngle )
 {
-  DBG( AWT_GRA, printf("drawArc: %p, %d,%d-%d,%d  %d,%d\n", gr,
+  DBG( AWT_GRA, printf("drawArc: %d,%d-%d,%d  %d,%d\n",
 				 x,y,width,height, startAngle,arcAngle));
-
-  XDrawArc( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height,
-			startAngle<<6, arcAngle<<6);
-  XFLUSH( X, False);
+  gdk_draw_arc( gr->drw, gr->gc, 0, x+gr->x0, y+gr->y0, width, height, startAngle<<6, arcAngle<<6);
 }
 
 
@@ -273,12 +264,9 @@
 								   jint x, jint y, jint width, jint height,
 								   jint startAngle, jint arcAngle )
 {
-  DBG( AWT_GRA, printf("fillArc: %p, %d,%d-%d,%d  %d,%d\n", gr,
+  DBG( AWT_GRA, printf("fillArc: %d,%d-%d,%d  %d,%d\n",
 				 x,y,width,height, startAngle, arcAngle));
-
-  XFillArc( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height,
-			startAngle<<6, arcAngle<<6);
-  XFLUSH( X, False);
+  gdk_draw_arc( gr->drw, gr->gc, 1, x+gr->x0, y+gr->y0, width, height, startAngle<<6, arcAngle<<6);
 }
 
 
@@ -286,10 +274,8 @@
 Java_java_awt_Toolkit_graDrawOval ( JNIEnv* env, jclass clazz, Graphics* gr,
 									jint x, jint y, jint width, jint height )
 {
-  DBG( AWT_GRA, printf("drawOval: %p, %d,%d - %d,%d\n", gr, x,y,width,height));
-
-  XDrawArc( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height, 0, 23040);
-  XFLUSH( X, False);
+  DBG( AWT_GRA, printf("drawOval: %d,%d - %d,%d\n", x,y,width,height));
+  gdk_draw_arc( gr->drw, gr->gc, 0, x+gr->x0, y+gr->y0, width, height, 0, 23040);
 }
 
 
@@ -297,14 +283,12 @@
 Java_java_awt_Toolkit_graFillOval ( JNIEnv* env, jclass clazz, Graphics* gr,
 									jint x, jint y, jint width, jint height )
 {
-  DBG( AWT_GRA, printf("fillOval: %p, %d,%d - %d,%d\n", gr, x,y,width,height));
-
-  XFillArc( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height, 0, 23040);
-  XFLUSH( X, False);
+  DBG( AWT_GRA, printf("fillOval: %d,%d - %d,%d\n", x,y,width,height));
+  gdk_draw_arc( gr->drw, gr->gc, 1, x+gr->x0, y+gr->y0, width, height, 0, 23040);
 }
 
 
-int jarray2Points ( JNIEnv* env, Toolkit* X, XPoint** pp, int x0, int y0,
+int jarray2Points ( JNIEnv* env, Toolkit* X, GdkPoint** pp, int x0, int y0,
 			jintArray xPoints, jintArray yPoints, int nPoints )
 {
   register int i;
@@ -316,7 +300,7 @@
   if ( (n = (*env)->GetArrayLength( env, xPoints)) < nPoints ) nPoints = n;
   if ( (n = (*env)->GetArrayLength( env, yPoints)) < nPoints ) nPoints = n;
 
-  *pp = getBuffer( X, (nPoints+1)*sizeof(XPoint));
+  *pp = getBuffer( X, (nPoints+1)*sizeof(GdkPoint));
 
   for ( i=0; i<nPoints; i++){
 	(*pp)[i].x = jx[i] + x0;
@@ -337,7 +321,7 @@
   int n;
   XPoint   *p;
 
-  DBG( AWT_GRA, printf("drawPolygon: %p, %p,%p  %d\n", gr, xPoints, yPoints, nPoints));
+  DBG( AWT_GRA, printf("drawPolygon: %p,%p  %d\n", xPoints, yPoints, nPoints));
 
   if ( !xPoints || !yPoints ) return;
 
@@ -349,9 +333,7 @@
 	p[nPoints].y = p[0].y;
 	nPoints++;
   }
-
-  XDrawLines( X->dsp, gr->drw, gr->gc, p, nPoints, CoordModeOrigin);
-  XFLUSH( X, False);
+  gdk_draw_lines( gr->drw, gr->gc, p, nPoints );
 }
 
 
@@ -359,15 +341,14 @@
 Java_java_awt_Toolkit_graDrawPolyline ( JNIEnv* env, jclass clazz, Graphics* gr,
 										jintArray xPoints, jintArray yPoints, jint nPoints )
 {
-  XPoint   *p;
+  GdkPoint   *p;
 
-  DBG( AWT_GRA, printf("drawPolyline: %p, %p,%p  %d\n", gr, xPoints, yPoints, nPoints));
+  DBG( AWT_GRA, printf("drawPolyline: %p,%p  %d\n", xPoints, yPoints, nPoints));
 
   if ( !xPoints || !yPoints ) return;
 
   nPoints = jarray2Points( env, X, &p, gr->x0, gr->y0, xPoints, yPoints, nPoints);
-  XDrawLines( X->dsp, gr->drw, gr->gc, p, nPoints, CoordModeOrigin);
-  XFLUSH( X, False);
+  gdk_draw_lines( gr->drw, gr->gc, p, nPoints );
 }
 
 
@@ -382,8 +363,7 @@
   if ( !xPoints || !yPoints ) return;
 
   nPoints = jarray2Points( env, X, &p, gr->x0, gr->y0, xPoints, yPoints, nPoints);
-  XFillPolygon( X->dsp, gr->drw, gr->gc, p, nPoints, Nonconvex, CoordModeOrigin);
-  XFLUSH( X, False);
+  gdk_draw_polygon( gr->drw, gr->gc, 1, p, nPoints);
 }
 
 
@@ -394,8 +374,7 @@
   DBG( AWT_GRA, printf("drawRect: %p, %d,%d - %d,%d\n", gr, x,y,width,height));
 
   if ( (width >= 0) && (height >= 0) )
-	XDrawRectangle( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height);
-  XFLUSH( X, False);
+    gdk_draw_rectangle( gr->drw, gr->gc, 0, x+gr->x0, y+gr->y0, width, height);
 }
 
 
@@ -406,17 +385,8 @@
   DBG( AWT_GRA, printf("fillRect: %p, %d,%d - %d,%d\n", gr, x,y,width,height));
 
   if ( (width >= 0) && (height >= 0) ) {
-	if ( width == 1 ) {   /* some swing gimmicks */
-	  XDrawLine( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, x+gr->x0, y +gr->y0 +height -1);
-	}
-	else if ( height == 1 ){
-	  XDrawLine( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, x +gr->x0 +width -1, y+gr->y0);
-	}
-	else {
-	  XFillRectangle( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, width, height);
-	}
+    gdk_draw_rectangle( gr->drw, gr->gc, 1, x+gr->x0, y+gr->y0, width, height);
   }
-  XFLUSH( X, False);
 }
 
 
@@ -438,24 +408,22 @@
   a = wArc / 2; b = hArc / 2;
 
   x1 = x + a;   x2 = x + width - a;  y2 = y + height;
-  XDrawLine( X->dsp, gr->drw, gr->gc, x1, y, x2, y);
-  XDrawLine( X->dsp, gr->drw, gr->gc, x1, y2, x2, y2);
+  gdk_draw_line( gr->drw, gr->gc, x1, y, x2, y);
+  gdk_draw_line( gr->drw, gr->gc, x1, y2, x2, y2);
 
   y1 = y + b;   y2 = y + height - b; x2 = x + width;
-  XDrawLine( X->dsp, gr->drw, gr->gc, x, y1, x, y2);
-  XDrawLine( X->dsp, gr->drw, gr->gc, x2, y1, x2, y2);
+  gdk_draw_line( gr->drw, gr->gc, x, y1, x, y2);
+  gdk_draw_line( gr->drw, gr->gc, x2, y1, x2, y2);
 
-  XDrawArc( X->dsp, gr->drw, gr->gc, x, y, wArc, hArc, 90*64, 90*64);
+  gdk_draw_arc( gr->drw, gr->gc, 0, x, y, wArc, hArc, 90*64, 90*64);
 
   x2 = x + width - wArc;
-  XDrawArc( X->dsp, gr->drw, gr->gc, x2, y, wArc, hArc, 0, 90*64);
+  gdk_draw_arc( gr->drw, gr->gc, 0, x2, y, wArc, hArc, 0, 90*64);
 
   y2 = y + height - hArc;
-  XDrawArc( X->dsp, gr->drw, gr->gc, x2, y2, wArc, hArc, 0, -90*64);
+  gdk_draw_arc( gr->drw, gr->gc, 0, x2, y2, wArc, hArc, 0, -90*64);
 
-  XDrawArc( X->dsp, gr->drw, gr->gc, x, y2, wArc, hArc, 180*64, 90*64);
-
-  XFLUSH( X, False);
+  gdk_draw_arc( gr->drw, gr->gc, 0, x, y2, wArc, hArc, 180*64, 90*64);
 }
 
 void
@@ -473,28 +441,25 @@
 
   y1 = y + b;  y2 = y + height - b;
   if ( y2 > y1 )
-	XFillRectangle( X->dsp, gr->drw, gr->gc, x, y1, width, y2-y1);
+    gdk_draw_rectangle( gr->drw, gr->gc, 1, x, y1, width, y2-y1);
   
   x1 = x + a;  x2 = x + width - a;
   if ( x2 > x1 ) {
-	XFillRectangle( X->dsp, gr->drw, gr->gc, x1, y, (x2-x1), b);
-	XFillRectangle( X->dsp, gr->drw, gr->gc, x1, y2, (x2-x1), b);
+    gdk_draw_rectangle( gr->drw, gr->gc, 1, x1, y, (x2-x1), b);
+    gdk_draw_rectangle( gr->drw, gr->gc, 1, x1, y2, (x2-x1), b);
   }
 
-  XFillArc( X->dsp, gr->drw, gr->gc, x, y, wArc, hArc, 90*64, 90*64);
-
+  gdk_draw_arc( gr->drw, gr->gc, 1, x, y, wArc, hArc, 90*64, 90*64);
+  
   x2 = x + width - wArc;
-  XFillArc( X->dsp, gr->drw, gr->gc, x2, y, wArc, hArc, 0, 90*64);
+  gdk_draw_arc( gr->drw, gr->gc, 1, x2, y, wArc, hArc, 0, 90*64);
 
   y2 = y + height - hArc;
-  XFillArc( X->dsp, gr->drw, gr->gc, x2, y2, wArc, hArc, 0, -90*64);
+  gdk_draw_arc( gr->drw, gr->gc, 1, x2, y2, wArc, hArc, 0, -90*64);
 
-  XFillArc( X->dsp, gr->drw, gr->gc, x, y2, wArc, hArc, 180*64, 90*64);
-
-  XFLUSH( X, False);
+  gdk_draw_arc( gr->drw, gr->gc, 1, x, y2, wArc, hArc, 180*64, 90*64);
 }
 
-
 void
 Java_java_awt_Toolkit_graDraw3DRect ( JNIEnv* env, jclass clazz, Graphics* gr,
 									  jint x, jint y, jint width, jint height,
@@ -502,6 +467,7 @@
 {
   int      bright, dark;
   int      xw, yh;
+  GdkColor c;
 
   DBG( AWT_GRA, printf("draw3DRect: %p, %d,%d - %d,%d  %d %x\n", gr,
 				 x,y,width,height, raised, rgb));
@@ -514,17 +480,15 @@
   xw = x + width;
   yh = y + height;
 
-  XSetForeground( X->dsp, gr->gc, (raised ? bright : dark));
-  XDrawLine( X->dsp, gr->drw, gr->gc, x, y, xw-1, y);
-  XDrawLine( X->dsp, gr->drw, gr->gc, x, y, x, yh);
-
-  XSetForeground( X->dsp, gr->gc, (raised ? dark : bright));
-  XDrawLine( X->dsp, gr->drw, gr->gc, x+1, yh, xw, yh);
-  XDrawLine( X->dsp, gr->drw, gr->gc, xw, y, xw, yh);
-
-  XSetForeground( X->dsp, gr->gc, gr->fg);
+  gdk_gc_set_foreground( gr->gc, (raised ? getColor( bright,&c) : getColor(dark,&c)));
+  gdk_draw_line( gr->drw, gr->gc, x, y, xw-1, y);
+  gdk_draw_line( gr->drw, gr->gc, x, y, x, yh);
+
+  gdk_gc_set_foreground( gr->gc, (raised ? getColor(dark,&c) : getColor(bright,&c)));
+  gdk_draw_line( gr->drw, gr->gc, x+1, yh, xw, yh);
+  gdk_draw_line( gr->drw, gr->gc, xw, y, xw, yh);
 
-  XFLUSH( X, False);
+  gdk_gc_set_foreground( gr->gc, getColor(gr->fg,&c));
 }
 
 void
@@ -535,8 +499,7 @@
   DBG( AWT_GRA, printf("fill3DRect: %p, %d,%d - %d,%d  %d %x\n", gr,
 				 x,y,width,height, raised, rgb));
 
-  XFillRectangle( X->dsp, gr->drw, gr->gc, x+gr->x0+1, y+gr->y0+1, width-2, height-2);
-
+  gdk_draw_rectangle( gr->drw, gr->gc, 1, x+gr->x0+1, y+gr->y0+1, width-2, height-2);
   Java_java_awt_Toolkit_graDraw3DRect( env, clazz, gr, x, y, width-1, height-1, raised, rgb);
 }
 
@@ -553,37 +516,40 @@
 Java_java_awt_Toolkit_graSetClip ( JNIEnv* env, jclass clazz, Graphics* gr,
 								   jint xClip, jint yClip, jint wClip, jint hClip )
 {
-  XRectangle rect;
-
+  GdkRectangle rect;
+  
   DBG( AWT_GRA, printf("setClip: %p, %d,%d - %d,%d\n", gr, xClip, yClip, wClip, hClip));
 
   rect.x      = xClip;
   rect.y      = yClip;
   rect.width  = (wClip > 0) ? wClip : 0;
   rect.height = (hClip > 0) ? hClip : 0;
-  XSetClipRectangles( X->dsp, gr->gc, gr->x0, gr->y0, &rect, 1, Unsorted);
+  gdk_gc_set_clip_origin( gr->gc, gr->x0, gr->y0);
+  gdk_gc_set_clip_rectangle( gr->gc, &rect);
 }
 
 void
 Java_java_awt_Toolkit_graSetColor ( JNIEnv* env, jclass clazz, Graphics* gr, jint clr )
 {
+  GdkColor c;
   DBG( AWT_GRA, printf("setColor: %p, %x\n", gr, clr));
 
   gr->fg = clr;
 
-  if ( gr->xor )
+  if ( gr->_xor )
 	clr ^= gr->xclr;
 
-  XSetForeground( X->dsp, gr->gc, clr);
+  gdk_gc_set_foreground( gr->gc, getColor( clr,&c));
 }
 
 void
 Java_java_awt_Toolkit_graSetBackColor ( JNIEnv* env, jclass clazz, Graphics* gr, jint clr )
 {
+  GdkColor c;
   DBG( AWT_GRA, printf("setBackColor: %p, %x\n", gr, clr));
 
   gr->bg = clr;
-  XSetBackground( X->dsp, gr->gc, clr);
+  gdk_gc_set_background( gr->gc, getColor(clr,&c));
 }
 
 void
@@ -591,7 +557,7 @@
 {
   DBG( AWT_GRA, printf("setFont: %p, %p\n", gr, fnt));
 
-  XSetFont( X->dsp, gr->gc, ((XFontStruct*)fnt)->fid);
+  gdk_gc_set_font( gr->gc, (GdkFont*)fnt);
 }
 
 void
@@ -606,22 +572,24 @@
 void
 Java_java_awt_Toolkit_graSetPaintMode ( JNIEnv* env, jclass clazz, Graphics* gr )
 {
+  GdkColor c;
   DBG( AWT_GRA, printf("setPaintMode: %p\n", gr));
 
-  gr->xor = 0;
-  XSetForeground( X->dsp, gr->gc, gr->fg);
-  XSetFunction( X->dsp, gr->gc, GXcopy);
+  gr->_xor = 0;
+  gdk_gc_set_foreground( gr->gc, getColor(gr->fg,&c));
+  gdk_gc_set_function( gr->gc, GDK_COPY);  
 }
 
 void
 Java_java_awt_Toolkit_graSetXORMode ( JNIEnv* env, jclass clazz, Graphics* gr, jint xorClr )
 {
+  GdkColor c;
   DBG( AWT_GRA, printf("setXORMode: %p, %x\n", gr, xorClr));
 
-  gr->xor = 1;
+  gr->_xor = 1;
   gr->xclr = xorClr;
-  XSetForeground( X->dsp, gr->gc, gr->fg ^ xorClr);
-  XSetFunction( X->dsp, gr->gc, GXxor);
+  gdk_gc_set_foreground( gr->gc, getColor( gr->fg ^ xorClr, &c));
+  gdk_gc_set_function( gr->gc, GDK_XOR);
 }
 
 void
@@ -653,6 +621,7 @@
 				 jint srcX, jint srcY, jint dstX, jint dstY,
 				 jint width, jint height, jint bgval )
 {
+#if 0
   Image  *dstImg = 0;
   XImage *dstXim = 0;
   int    i, j, si, sj, alpha;
@@ -725,6 +694,7 @@
 
 	XFLUSH( X, True);
   }
+#endif
 }
 
 
@@ -736,6 +706,9 @@
 {
   XGCValues values;
 
+  GdkColor cb;
+  GdkGCPrivate *private = (GdkGCPrivate*) gr->gc;
+
   DBG( AWT_GRA, printf("drawImage: %p %p (%p,%p,%p %d,%d) %d,%d, %d,%d, %d,%d, %x\n",
 				 gr, img,  img->xImg,img->xMask,img->alpha,  img->width,img->height,
 				 srcX,srcY,  dstX,dstY,	 width,height, bgval));
@@ -745,42 +718,32 @@
   dstX += gr->x0;
   dstY += gr->y0;
 
-  dstX += img->left;
-  dstY += img->top;
-
   if ( img->pix ) {
-	XCopyArea( X->dsp, img->pix, gr->drw, gr->gc, srcX, srcY, width, height, dstX, dstY);
+    gdk_draw_pixmap( gr->drw, gr->gc, img->pix, srcX, srcY, dstX, dstY, width, height);
   }
   else if ( img->xImg ) {
 	if ( img->xMask ) {
 	  /* save current gc values, we have to change them temporarily */
-	  XGetGCValues( X->dsp, gr->gc, GCFunction|GCPlaneMask|GCForeground|GCBackground,
-					&values);
+          XGetGCValues( private->xdisplay, private->xgc, GCFunction|GCPlaneMask|GCForeground|GCBackground, &values);
 
 	  /* in case we have a specified background color, fill area */
 	  if ( bgval != -1 ) {
-		XSetForeground( X->dsp, gr->gc, bgval);
-		XFillRectangle( X->dsp, gr->drw, gr->gc, dstX, dstY, width, height);
+            cb.pixel = bgval;
+            gdk_gc_set_foreground( gr->gc, &cb);
+            gdk_draw_rectangle( gr->drw, gr->gc, TRUE, dstX, dstY, width, height);            
 	  }
 
 	  /* set attributes so that a subsequent image draw leaves the mask pels unmodified */
-	  XSetFunction( X->dsp, gr->gc, GXandInverted);
-	  XSetForeground( X->dsp, gr->gc, 0xffffffff);
-	  XSetBackground( X->dsp, gr->gc, 0);
+          XSetFunction( private->xdisplay, private->xgc, GXandInverted);
+          XSetForeground( private->xdisplay, private->xgc, 0xffffffff);
+          XSetBackground( private->xdisplay, private->xgc, 0);
 
 	  /* draw the mask bitmap */
-	  if ( img->shmiMask ){
-		XShmPutImage( X->dsp, gr->drw, gr->gc, img->xMask,
-					  srcX, srcY, dstX, dstY, width, height, False);
-	  }
-	  else {
-		XPutImage( X->dsp, gr->drw, gr->gc, img->xMask,
-				   srcX, srcY, dstX, dstY, width, height);
-	  }
+          gdk_draw_image( gr->drw, gr->gc, img->xMask, srcX, srcY, dstX, dstY, width, height);
 
 	  /* restore gc values except of the function */
-	  XChangeGC( X->dsp, gr->gc, GCFunction|GCPlaneMask|GCForeground|GCBackground, &values);
-	  XSetFunction( X->dsp, gr->gc, GXor);
+          XChangeGC( private->xdisplay, private->xgc, GCFunction|GCPlaneMask|GCForeground|GCBackground, &values);
+          XSetFunction( private->xdisplay, private->xgc, GXor);
 	}
 	else if ( img->alpha ) {
 	  drawAlphaImage( gr, img, srcX, srcY, dstX, dstY, width, height, bgval);
@@ -788,21 +751,12 @@
 	}
 
 	/* this is the real image drawing */
-	if ( img->shmiImg ){
-	  XShmPutImage( X->dsp, gr->drw, gr->gc, img->xImg,
-					srcX, srcY, dstX, dstY, width, height, False);
-	}
-	else {
-	  XPutImage( X->dsp, gr->drw, gr->gc, img->xImg,
-				 srcX, srcY, dstX, dstY, width, height);
-	}
+        gdk_draw_image( gr->drw, gr->gc, img->xImg, srcX, srcY, dstX, dstY, width, height);
 
 	/* in case we had a mask, restore the original function */
 	if ( img->xMask )
-	  XSetFunction( X->dsp, gr->gc, values.function);
+             XSetFunction( private->xdisplay, private->xgc, values.function);
   }
-
-  XFLUSH( X, True);
 }
 
 
@@ -811,13 +765,11 @@
 										   jint dx0, jint dy0, jint dx1, jint dy1,
 										   jint sx0, jint sy0, jint sx1, jint sy1, jint bgval )
 {
-  int        iw, x0, y0, x1, y1;
-  Image      *tgt;
-  int        tmpXImg = (img->xImg == NULL);
-
   DBG( AWT_GRA, printf("drawImageScaled: %p %p (%p), %d,%d,%d,%d, %d,%d,%d,%d, %x\n",
 				 gr, img, img->xImg, dx0, dy0, dx1, dy1, sx0, sy0, sx1, sy1, bgval));
 
+  Java_java_awt_Toolkit_graDrawImage( env, clazz, gr, img, sx0, sy0, dx0, dy0, sx1-sx0, sy1-sy0, bgval);
+#if 0  
   if ( !img ) return;
 
   /* screen images don't have an XImage, we have to get the data first */
@@ -863,6 +815,9 @@
 
   if ( tmpXImg ) {
 	XDestroyImage( img->xImg);
-	img->xImg = NULL;
   }
 }
+	img->xImg = NULL;
+#endif
+}
+
diff -urN kaffe-1.1.4/libraries/clib/awt/X/img.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/img.c
--- kaffe-1.1.4/libraries/clib/awt/X/img.c	2003-08-04 20:41:25.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/img.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,6 +4,9 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
@@ -37,6 +40,7 @@
   return img;
 }
 
+#if 0 /* Unused */
 static int
 createShmXImage ( Toolkit* X, Image* img, int depth, int isMask )
 {
@@ -126,42 +130,34 @@
 	X->shm = USE_SHM;
 #endif
 }
+#endif /* Ununsed */
 
 
+GdkImage*
+createXMaskImage ( Toolkit* X, Image* img )
+{
+  gpointer   data;
+  GdkVisual* vis = gdk_visual_get_system();
+  int        bytes_per_line, nBytes;
 
-void
+  bytes_per_line = (img->width + 7) / 8;
+  nBytes = bytes_per_line * img->height;
+
+  data = AWT_MALLOC( nBytes);
+  memset( data, 0xff, nBytes);
+
+  return gdk_image_new_bitmap( vis, data, img->width, img->height);
+}
+
+
+GdkImage*
 createXImage ( Toolkit* X, Image* img )
 {
-  int bitmap_pad;
-  int bytes_per_line;
-  int bytes_per_pix;
-  unsigned int nPix;
-  char *data;
-  Visual *vis  = DefaultVisual( X->dsp, DefaultScreen( X->dsp));
-  int    depth = DefaultDepth(  X->dsp, DefaultScreen( X->dsp));
-	
-  if ( depth <= 8)	      bytes_per_pix = 1;
-  else if ( depth <= 16)  bytes_per_pix = 2;
-  else			          bytes_per_pix = 4;
-
-  bytes_per_line = bytes_per_pix * img->width;
-  bitmap_pad = bytes_per_pix * 8;
-  nPix = img->width * img->height;
-
-  if ( (X->shm == USE_SHM) && (nPix > X->shmThreshold) && (img->alpha == 0) ) {
-	if ( createShmXImage( X, img, depth, False) ){
-	  DBG( AWT_IMG, printf("alloc Shm: %p %p %p (%dx%d) \n", img, img->xImg, img->shmiImg,
-					  img->width, img->height));
-	  return;
-	}
-  }
-
-  data = AWT_CALLOC( nPix, bytes_per_pix);
-  img->xImg = XCreateImage( X->dsp, vis, depth, ZPixmap, 0,
-							data, img->width, img->height, bitmap_pad, bytes_per_line);
-  DBG( AWT_IMG, printf( "alloc: %p %p (%dx%d)\n", img, img->xImg, img->width, img->height));
+  GdkVisual* vis = gdk_visual_get_system();
+  return gdk_image_new( GDK_IMAGE_NORMAL, vis, img->width, img->height);
 }
 
+#if 0 /* Unused */
 void
 createXMaskImage ( Toolkit* X, Image* img )
 {
@@ -189,9 +185,9 @@
 							 data, img->width, img->height, 8, bytes_per_line );
   DBG( AWT_IMG, printf( "alloc mask: %p %p (%dx%d)\n", img, img->xMask, img->width, img->height));
 }
+#endif
 
-
-void
+AlphaImage*
 createAlphaImage ( Toolkit* X, Image *img )
 {
   int nBytes = img->width * img->height;
@@ -202,6 +198,7 @@
   img->alpha->height = img->height;
   img->alpha->buf = AWT_MALLOC( nBytes);
   memset( img->alpha->buf, 0xff, nBytes);
+  return img;
 }
 
 /*
@@ -239,6 +236,7 @@
 void
 reduceAlpha ( Toolkit* X, Image* img, int threshold )
 {
+#if 0
   int i, j, a;
 
   if ( !img->alpha )
@@ -259,6 +257,7 @@
   AWT_FREE( img->alpha->buf);
   AWT_FREE( img->alpha);
   img->alpha = 0;
+#endif
 }
 
 
@@ -299,20 +298,19 @@
   int            yi = (dy) ? y+1 : y;
 
   if ( img->xMask ) {
-	ul = XGetPixel( img->xMask, x, y);
-	ur = XGetPixel( img->xMask, xi, y);
-	ll = XGetPixel( img->xMask, x, yi);
-	lr = XGetPixel( img->xMask, xi,yi);
+        ul = gdk_image_get_pixel( img->xMask, x, y);
+        ur = gdk_image_get_pixel( img->xMask, xi, y);
+        ll = gdk_image_get_pixel( img->xMask, x, yi);
+        lr = gdk_image_get_pixel( img->xMask, xi,yi);
 	
 	if ( !interpolate( ul, ur, ll, lr, dx, dy) )
 	  return -1;
   }
 
-  ul = XGetPixel( img->xImg, x, y);
-  ur = XGetPixel( img->xImg, xi, y);
-  ll = XGetPixel( img->xImg, x, yi);
-  lr = XGetPixel( img->xImg, xi,yi);
-
+  ul = gdk_image_get_pixel( img->xImg, x, y);
+  ur = gdk_image_get_pixel( img->xImg, xi, y);
+  ll = gdk_image_get_pixel( img->xImg, x, yi);
+  lr = gdk_image_get_pixel( img->xImg, xi,yi);
 
   if ( (ul == ur) && (ll == ul) && (lr == ll) ) {
 	rgbValues( X, ul, &r, &g, &b);
@@ -362,13 +360,13 @@
 	  sxDelta = (sx < (sx1-1)) ? sX - sx : 0;
 
 	  if ( (c = getScaledPixel( X, src, sx, sy, sxDelta, syDelta)) != -1 ){
-  		XPutPixel( tgt->xImg, dx, dy, c);
+                gdk_image_put_pixel( tgt->xImg, dx, dy, c);
 		if ( src->alpha )
-		  PutAlpha( tgt->alpha, dx, dy, getScaledAlpha( X, src, sx, sy, sxDelta, syDelta));
+                  PutAlpha( tgt->alpha, dx, dy, getScaledAlpha( X, src, sx, sy, sxDelta, syDelta));
 	  }
 	  else {
-		XPutPixel( tgt->xMask, dx, dy, 0);
-		XPutPixel( tgt->xImg, dx, dy, 0);
+                gdk_image_put_pixel( tgt->xMask, dx, dy, 0);
+                gdk_image_put_pixel( tgt->xImg, dx, dy, 0);
 	  }
 	}
   }
@@ -393,9 +391,11 @@
 Java_java_awt_Toolkit_imgCreateScreenImage ( JNIEnv* env, jclass clazz, jint width, jint height )
 {
   Image  *img = createImage( width, height);
+#if 0
   int    depth = DefaultDepth(  X->dsp, DefaultScreen( X->dsp));
 
   img->pix  = XCreatePixmap( X->dsp, X->root, width, height, depth);
+#endif
   return img;
 }
 
@@ -408,6 +408,7 @@
 		jintArray clrMap, jbyteArray idxPels, jint trans,
 		jint off, jint scan)
 {
+#if 0
   register int    row, col;
   unsigned long   pix;
   jint            rgb;
@@ -439,6 +440,7 @@
 
   (*env)->ReleaseIntArrayElements( env, clrMap, clr, JNI_ABORT);
   (*env)->ReleaseByteArrayElements( env, idxPels, pel, JNI_ABORT);
+#endif
 }
 
 
@@ -447,6 +449,7 @@
 									  jint x, jint y, jint w, jint h,
 									  jintArray rgbPels, jint off, jint scan)
 {
+#if 0
   register int    row, col;
   unsigned long   pix = 0;
   jboolean        isCopy;
@@ -485,6 +488,7 @@
   }
 
   (*env)->ReleaseIntArrayElements( env, rgbPels, rgbs, JNI_ABORT);
+#endif
 }
 
 void
@@ -503,6 +507,7 @@
 void
 Java_java_awt_Toolkit_imgFreeImage( JNIEnv* env, jclass clazz, Image * img)
 {
+#if 0
   Image *next, *first = img;
 
   /* we have to be aware of image rings (GIF movies), iterate */
@@ -558,6 +563,7 @@
 	AWT_FREE( img);
 	img = next;
   } while ( (img != 0) && (img != first) );
+#endif
 }
 
 
@@ -568,7 +574,7 @@
   int depth;
 
   Image *scaledImg = createImage( width, height);
-
+#if 0
   if ( img->xImg ) {
 	createXImage( X, scaledImg);
 	if ( img->xMask )
@@ -582,7 +588,7 @@
 	depth = DefaultDepth(  X->dsp, DefaultScreen( X->dsp));
 	scaledImg->pix  = XCreatePixmap( X->dsp, X->root, width, height, depth);
   }
-
+#endif
   return scaledImg;
 }
 
@@ -590,6 +596,7 @@
 void
 Java_java_awt_Toolkit_imgProduceImage ( JNIEnv* env, jclass clazz, jobject producer, Image* img )
 {
+#if 0
   int            i, j;
   int            r, g, b;
   unsigned long  pix;
@@ -650,6 +657,7 @@
 
   (*env)->CallVoidMethod( env, producer, setPix, 0, 0, img->width, img->height, model, pelArray, 0, img->width);
   (*env)->CallVoidMethod( env, producer, imgCompl, 3); /* 3 = STATICIMAGEDONE */
+#endif
 }
 
 
@@ -686,8 +694,10 @@
   char  *fn = java2CString( env, X, fileName);
   unsigned char  sig[SIG_LENGTH];
 
+#if 0
   if (!X->colorMode)
 	initColorMapping( env, clazz, X );
+#endif  
 
   if ( (infile = AWT_OPEN( fn)) >= 0 ) {
 	if ( AWT_READ( infile, sig, sizeof(sig)) == sizeof(sig) ) {
@@ -718,6 +728,7 @@
 										  jbyteArray jbuffer, jint off, jint len )
 {
   Image *img = 0;
+#if 0
   jboolean isCopy;
   jint   length = (*env)->GetArrayLength( env, jbuffer);
   jbyte  *jb = (*env)->GetByteArrayElements( env, jbuffer, &isCopy);
@@ -741,6 +752,7 @@
   }
 
   (*env)->ReleaseByteArrayElements( env, jbuffer, jb, JNI_ABORT);
+#endif
   return img;  
 }
 
@@ -748,7 +760,7 @@
 Java_java_awt_Toolkit_imgSetFrame ( JNIEnv* env, jclass clazz, Image* img, int frameNo )
 {
   Image *imgCur = img;
-
+#if 0
   if ( !img->next )
 	return img;
 
@@ -758,7 +770,7 @@
 		break;
 	}
   }
-
+#endif
   return img;
 }
 
@@ -782,17 +794,20 @@
 jboolean
 Java_java_awt_Toolkit_imgIsMultiFrame ( JNIEnv* env, jclass clazz, Image* img)
 {
-  return (img->next != 0);
+//  return (img->next != 0);
+  return FALSE;
 }
 
 jint
 Java_java_awt_Toolkit_imgGetLatency ( JNIEnv* env, jclass clazz, Image* img)
 {
-  return img->latency;
+//  return img->latency;
+  return 0;
 }
 
 void*
 Java_java_awt_Toolkit_imgGetNextFrame ( JNIEnv* env, jclass clazz, Image* img )
 {
-  return img->next;   /* next in the ring */
+//  return img->next;   /* next in the ring */
+  return 0;
 }
diff -urN kaffe-1.1.4/libraries/clib/awt/X/imggif.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/imggif.c
--- kaffe-1.1.4/libraries/clib/awt/X/imggif.c	2000-01-19 19:04:31.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/imggif.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,6 +4,9 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
@@ -41,13 +44,13 @@
 	idx = rowBuf[col];
 	if ( img->xMask && (idx == img->trans) ) {
 	  pix = 0;
-	  XPutPixel( img->xMask, col, row, 0);
+          gdk_image_put_pixel( img->xMask, col, row, 0);	  
 	}
 	else {
 	  rgb = (cm[idx].Red << 16) | (cm[idx].Green << 8) | (cm[idx].Blue);
 	  pix = pixelValue( X, rgb);
 	}
-	XPutPixel( img->xImg, col, row, pix);
+	gdk_image_put_pixel( img->xImg, col, row, pix);
   }
 }
 
@@ -63,7 +66,7 @@
 static Image*
 readGif ( GifFileType *gf )
 {
-  Image*          firstImg = 0;
+//  Image*          firstImg = 0;
   Image*	  img = 0;
   int             i, extCode, width, height, row, cmapSize;
   int             trans = -1, nFrames = 0, delay = 0;
@@ -86,7 +89,7 @@
       cmap     = (gf->Image.ColorMap) ? gf->Image.ColorMap : gf->SColorMap;
 	  clrs     = cmap->Colors;
       cmapSize = cmap->ColorCount;
-
+#if 0
 	  /*
 	   * create our image objects and keep track of frames 
 	   */
@@ -128,7 +131,7 @@
 
 	  nFrames++;
 	  createXImage( X, img);
-
+#endif
 	  /*
 	   * start reading in the image data
 	   */
@@ -181,12 +184,13 @@
 	  break;
 	}
   } while ( rec != TERMINATE_RECORD_TYPE );
-
+#if 0
   if ( firstImg && (img != firstImg) ){
 	img->next = firstImg;   /* link it together (as a ring) */
   }
-
   return firstImg;
+#endif
+  return img;  
 }
 
 /**************************************************************************************
diff -urN kaffe-1.1.4/libraries/clib/awt/X/imgjpeg.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/imgjpeg.c
--- kaffe-1.1.4/libraries/clib/awt/X/imgjpeg.c	2003-07-17 13:59:00.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/imgjpeg.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,6 +4,9 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
@@ -34,7 +37,7 @@
 /* references to img.c */
 Image* createImage ( int width, int height );
 void Java_java_awt_Toolkit_imgFreeImage( JNIEnv* env, jclass clazz, Image * img);
-void createXImage ( Toolkit* X, Image* img );
+GdkImage* createXImage ( Toolkit* X, Image* img );
 
 
 #ifdef INCLUDE_JPEG
@@ -70,7 +73,7 @@
 
 typedef bufsrc_mgr * bufsrc_ptr;
 
-
+#if 0
 #define BUF_SIZE 2048
 
 typedef struct {
@@ -82,7 +85,6 @@
 
 typedef filesrc_mgr * filesrc_ptr;
 
-
 /*******************************************************************************************
  * memory buffer extension for the standard jpeg lib input management (jdatasrc.c)
  */
@@ -261,7 +263,7 @@
 
   src->fd = fd;
 }
-
+#endif
 
 /************************************************************************************
  * JPEG auxiliary funcs (production callbacks)
@@ -270,6 +272,7 @@
 void
 jscan_cmap_to_img( Image * img, JSAMPROW buf, struct jpeg_decompress_struct * cinfo)
 {
+#if 0	
   register int col, pix, rgb, idx;
   register JSAMPARRAY colormap = cinfo->colormap;
 
@@ -279,6 +282,7 @@
     pix = pixelValue( X, rgb);
     XPutPixel( img->xImg, col, cinfo->output_scanline-1, pix);
   }
+#endif  
 }
 
 void
@@ -325,10 +329,10 @@
   if ( colors < 8 ) {
     colors = 8;
   }
-  else if ( colors > 256 ) {
+  else if ( colors > 256 )
     colors = 256;
+#if 0    
   }
-
   if (X->colorMode != CM_PSEUDO_256)
     colors = 0;
 
@@ -337,7 +341,9 @@
     cinfo->quantize_colors = TRUE;
   } else
     cinfo->quantize_colors = FALSE;
-
+#endif
+  cinfo->desired_number_of_colors = colors;
+  cinfo->quantize_colors = TRUE;
   cinfo->out_color_space = JCS_RGB;
 
   jpeg_start_decompress( cinfo);
@@ -345,15 +351,17 @@
 
   /* it's time to create the target image */
   img = createImage( cinfo->output_width, cinfo->output_height);
-  createXImage( X, img);
+  img->xImg = createXImage( X, img);
 
   buffer = (*cinfo->mem->alloc_sarray)((j_common_ptr) cinfo, JPOOL_IMAGE, row_stride, 1);
 
   while (cinfo->output_scanline < cinfo->output_height) {
     jpeg_read_scanlines( cinfo, buffer, 1);
+#if 0    
     if (colors)
       jscan_cmap_to_img( img, buffer[0], cinfo);
     else
+#endif	    
       jscan_to_img( img, buffer[0], cinfo);
   }
 
diff -urN kaffe-1.1.4/libraries/clib/awt/X/imgpng.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/imgpng.c
--- kaffe-1.1.4/libraries/clib/awt/X/imgpng.c	2003-01-14 07:27:53.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/imgpng.c	2004-03-12 21:25:59.000000000 +0800
@@ -27,9 +27,9 @@
 /* references to img.c */
 Image* createImage ( int width, int height );
 void Java_java_awt_Toolkit_imgFreeImage( JNIEnv* env, jclass clazz, Image * img);
-void createXImage ( Toolkit* X, Image* img );
-void createXMaskImage ( Toolkit* X, Image* img );
-void createAlphaImage ( Toolkit* X, Image* img );
+GdkImage*  createXImage ( Toolkit* X, Image* img );
+GdkImage*  createXMaskImage ( Toolkit* X, Image* img );
+AlphaImage* createAlphaImage ( Toolkit* X, Image* img );
 void reduceAlpha ( Toolkit* X, Image* img, int threshold );
 
 
@@ -87,9 +87,12 @@
 	png_read_row( png_ptr, row, 0);
 
 	for ( j=0, p=(unsigned char*)row; j<info_ptr->width; j++ ) {
+#if 0		
 	  argb = readARGB( &p,
 			   (img->alpha != 0)
 			   || (info_ptr->channels == 4));
+#endif
+          argb = readARGB( &p, (img->alpha != 0));	  
 	  setPixel( img, argb, i, j);
 	}
   }
@@ -170,8 +173,11 @@
 readPng ( png_structp png_ptr, png_infop info_ptr )
 {
   Image          *volatile img = 0;
+  png_uint_32    num_palette;
+  png_colorp     palette; 
   double         screen_gamma = 1.2, file_gamma;
-  int            i, number_passes;
+  png_color_16p  histogram;
+  int            i, intent, number_passes;
   int            row_bytes;
   png_bytepp     volatile rows = 0;
   png_bytep      volatile data = 0;
@@ -191,7 +197,6 @@
   /* handle gamma correction  */
   {
 #if defined(PNG_READ_sRGB_SUPPORTED)
-	int intent;
 	if ( png_get_sRGB( png_ptr, info_ptr, &intent) ) {
 		png_set_sRGB( png_ptr, info_ptr, intent);
 	}
@@ -217,10 +222,9 @@
   row_bytes     = png_get_rowbytes( png_ptr, info_ptr);
 
   /* time to create the image */
-  img = createImage( info_ptr->width, info_ptr->height);
+  img->xImg = createXImage( X, img);
   if ( hasAlpha( png_ptr) )
-	createAlphaImage( X, img);
-  createXImage( X, img);
+    img->alpha = createAlphaImage( X, img);
 
   if ( info_ptr->interlace_type != 0 ) {
 #ifndef OPTIMIZE_SPACE
diff -urN kaffe-1.1.4/libraries/clib/awt/X/tlk.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/tlk.c
--- kaffe-1.1.4/libraries/clib/awt/X/tlk.c	2003-01-07 01:14:25.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/tlk.c	2004-03-12 21:29:20.000000000 +0800
@@ -4,6 +4,9 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
@@ -14,50 +17,7 @@
 #include "toolkit.h"
 #include "tlkprops.h"
 
-/********************************************************************************
- * auxiliary functions
- */
-
-static int
-xErrorHandler ( Display *dsp, XErrorEvent *err )
-{
-  char buf[128];
-  char key[64];
-
-  /*
-   * If there are clueless apps using resident Graphics objects in
-   * asnyc drawing ops (without checking for window visibility first),
-   * we might get BadDrawable errors. Since this is clearly a bug
-   * of the app (which has to clean up resident Graphics objects
-   * before closing windows), we don't want to add costly checks
-   * on every Graphics op (which couldn't be safe, anyway).
-   * The only way to handle this safely would be to link Graphics
-   * objects to their targets, and this would add the danger of
-   * severe memory leaks in case the Graphics objects aren't disposed
-   * (for efficiency reasons, we cach Graphics instances).
-   * Ignoring BadDrawables is not very nice, but reasonably safe.
-   */
-  /*
-  if ( err->error_code == BadDrawable )
-	return 0;
-  */
-
-  sprintf( key, "%d", err->error_code);
-  XGetErrorDatabaseText( dsp, "XProtoError", key, "", buf, sizeof( buf));
-
-  DBG( AWT, printf("X error:      %s\n", buf));
-
-  sprintf( key, "%d", err->request_code);
-  XGetErrorDatabaseText( dsp, "XRequest", key, "", buf, sizeof( buf));
-
-  DBG( AWT, printf("  request:    %s\n", buf));
-  DBG( AWT, printf("  resource:   %lx\n", err->resourceid));
-
-  /* DBG( AWT, (*JniEnv)->ThrowNew( JniEnv, AWTError, "X error occured")); */
-
-  return 0;
-}
-
+jmethodID idleCallback;
 
 /********************************************************************************
  * exported functions
@@ -67,12 +27,6 @@
 Java_java_awt_Toolkit_tlkProperties ( JNIEnv* env, jclass clazz )
 {
   jint    props = TLK_EXTERNAL_DECO;
-
-#if !defined(USE_POLLING_AWT)
-  props |= TLK_IS_BLOCKING;
-  props |= TLK_NEEDS_FLUSH;
-#endif
-
   return props;
 }
 
@@ -80,143 +34,76 @@
 Java_java_awt_Toolkit_tlkInit ( JNIEnv* env, jclass clazz, jstring name )
 {
   char    *dspName;
-
+  int argc = 0;
+  
   getBuffer(X, 128);
-
   JniEnv = env;
   AWTError = (*env)->FindClass( env, "java/awt/AWTError");
 
-  XSetErrorHandler( xErrorHandler);
-
-  if ( name ) {
-	dspName = java2CString( env, X, name);
-  }
-  else {
-	if ( !(dspName = getenv( "DISPLAY")) )
-	  dspName = ":0.0";
-  }
-
-  if ( !(X->dsp = XOpenDisplay( dspName)) ) {
-	DBG( AWT, printf("XOpenDisplay failed: %s\n", dspName));
-	return JNI_FALSE;
+  initColorMapping( env, clazz, X);
+ 
+  if (!gtk_init_check (&argc, NULL)) {
+    DBG( AWT, fprintf(stderr, "Could not init Gtk+\n"));
+    return FALSE; 
   }
-
-#if !defined (USE_POLLING_AWT)
-  XInitThreads();
-#endif
-
-  DBG( AWT, printf("synchronize X\n"));
-  DBG_ACTION(awt, XSynchronize( X->dsp, True));
-
-  X->nWindows = 47;
-  X->windows = AWT_CALLOC( X->nWindows, sizeof(WindowRec));
-
-  X->root   = DefaultRootWindow( X->dsp);
-  X->fwdIdx = -1;
-
-#if defined(USE_XSHM_EXTENSION)
-  /*
-   * We just can use XShm in case we don't run remote, and we better don't rely on
-   * XShmQueryExtension to make this distinction
-   */
-  if ( (dspName[0] == ':') || (strncmp( "localhost", dspName, 9) == 0) ) {
-	if ( XShmQueryExtension( X->dsp) ){
-	  X->shm =  USE_SHM;
-	  /*
-	   * threshold shouldn't be much smaller than page size, since this is
-	   * usually the smallest amount of sharable memory, anyway
-	   */
-	  X->shmThreshold = 4096;
-	}
-  }
-#endif
-
-  WM_PROTOCOLS     = XInternAtom( X->dsp, "WM_PROTOCOLS", False);
-  WM_DELETE_WINDOW = XInternAtom( X->dsp, "WM_DELETE_WINDOW", False);
-
-  WM_TAKE_FOCUS    = XInternAtom( X->dsp, "WM_TAKE_FOCUS", False);
-  WAKEUP           = XInternAtom( X->dsp, "WAKEUP", False);
-  RETRY_FOCUS      = XInternAtom( X->dsp, "RETRY_FOCUS", False);
-  FORWARD_FOCUS    = XInternAtom( X->dsp, "FORWARD_FOCUS", False);
-
-  return JNI_TRUE;
+  // gtk_main();
 }
 
 void
 Java_java_awt_Toolkit_tlkTerminate ( JNIEnv* env, jclass clazz )
 {
   if ( X->cbdOwner ) {
-	XDestroyWindow( X->dsp, X->cbdOwner);
-	X->cbdOwner = 0;
-  }
-
-  if ( X->wakeUp ) {
-	XDestroyWindow( X->dsp, X->wakeUp);
-	X->wakeUp = 0;
-  }
-
-  if ( X->dsp ){
-	XSync( X->dsp, False);
-	XCloseDisplay( X->dsp);
-	X->dsp = 0;
-  }
+    gdk_window_destroy( X->cbdOwner);
+    X->cbdOwner = 0;
+  } 
+  gtk_main_quit();
+  gdk_flush();
 }
 
 
 jstring
 Java_java_awt_Toolkit_tlkVersion ( JNIEnv* env, jclass clazz )
 {
-  return (*env)->NewStringUTF( env, "X-1.0");
+  return (*env)->NewStringUTF( env, "GTK-1.0");
 }
 
 jint
 Java_java_awt_Toolkit_tlkGetResolution ( JNIEnv* env, jclass clazz )
 {
-  /*
-   * This is just a guess since WidthMMOfScreen most probably isn't exact.
-   * We are interested in pixels per inch
-   */
-  Screen *scr = DefaultScreenOfDisplay( X->dsp);
-  return ((WidthOfScreen( scr) * 254) + 5) / (WidthMMOfScreen( scr) *10);
+  return ((gdk_screen_width() * 254) + 5) / (gdk_screen_width_mm() * 10);
 }
 
 jint
 Java_java_awt_Toolkit_tlkGetScreenHeight ( JNIEnv* env, jclass clazz )
 {
-  return DisplayHeight( X->dsp, DefaultScreen( X->dsp));
+  return gdk_screen_height();
 }
 
 jint
 Java_java_awt_Toolkit_tlkGetScreenWidth ( JNIEnv* env, jclass clazz )
 {
-  return DisplayWidth( X->dsp, DefaultScreen( X->dsp));
+  return gdk_screen_width();
 }
 
 void
 Java_java_awt_Toolkit_tlkSync ( JNIEnv* env, jclass clazz )
 {
-  /*
-   * this one flushes the request buffer and waits until all reqs have been processed
-   * (a roundtrip for input based on prior requests)
-   */
-  XSync( X->dsp, False);
 }
 
 void
 Java_java_awt_Toolkit_tlkFlush ( JNIEnv* env, jclass clazz )
 {
-  /* simply flush request buffer (mainly for background threads and blocked AWT) */
-  XFlush( X->dsp);
 }
 
 
 void
 Java_java_awt_Toolkit_tlkBeep ( JNIEnv* env, jclass clazz )
 {
-  XBell( X->dsp, 100);
+  gdk_beep();
 }
 
 void
 Java_java_awt_Toolkit_tlkDisplayBanner ( JNIEnv* env, jclass clazz, jstring banner )
 {
 }
+
diff -urN kaffe-1.1.4/libraries/clib/awt/X/toolkit.h kaffe-1.1.4-gtkawt/libraries/clib/awt/X/toolkit.h
--- kaffe-1.1.4/libraries/clib/awt/X/toolkit.h	2003-01-14 07:27:53.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/toolkit.h	2004-03-12 21:25:59.000000000 +0800
@@ -4,6 +4,9 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
@@ -16,20 +19,9 @@
 #include "config-mem.h"
 #include "config-setjmp.h"
 
-#include <X11/Xlib.h>
-#include <X11/Xutil.h>
-
-#if defined(HAVE_LIBXEXT) && defined(HAVE_SYS_IPC_H) && defined(HAVE_SYS_SHM_H) && defined(HAVE_X11_EXTENSIONS_XSHM_H)
-#define USE_XSHM_EXTENSION 1
-#include <sys/ipc.h>
-#include <sys/shm.h>
-#include <X11/extensions/XShm.h>
-#else
-#undef USE_XSHM_EXTENSION
-#define	XShmGetImage(A,B,C,D,E,F)		0
-#define	XShmPutImage(A,B,C,D,E,F,G,H,I,J,K)	0
-#define	XShmSegmentInfo				void
-#endif
+#include <gtk/gtk.h>
+#include <gdk/gdk.h>
+#include <gdk/gdktypes.h>
 
 #include <jni.h>
 
@@ -44,6 +36,71 @@
 #include <fcntl.h>
 #endif
 
+jclass     ComponentEvent;
+jclass     MouseEvent;
+jclass     FocusEvent;
+jclass     WindowEvent;
+jclass     KeyEvent;
+jclass     PaintEvent;
+jclass     ActionEvent;
+jclass     ItemEvent;
+
+jmethodID  queueComponentEvent;
+jmethodID  queueMouseEvent;
+jmethodID  queueFocusEvent;
+jmethodID  queueWindowEvent;
+jmethodID  queueKeyEvent;
+jmethodID  queuePaintEvent;
+jmethodID  queueItemEvent;
+jmethodID  queueActionEvent;
+
+#define    COMPONENT_RESIZED    101
+
+#define    MOUSE_PRESSED        501
+#define    MOUSE_RELEASED       502
+#define    MOUSE_MOVED          503
+#define    MOUSE_ENTERED        504
+#define    MOUSE_EXITED         505
+
+#define    KEY_PRESSED          401
+#define    KEY_RELEASED         402
+
+#define    PAINT                800
+
+#define    FOCUS_GAINED        1004
+#define    FOCUS_LOST          1005
+
+#define    ITEM_SELECTED       1
+#define    ITEM_DESELECTED     2
+
+#define    ACTION_PERFORMED    1001
+
+#define    WINDOW_CLOSING       201
+#define    WINDOW_CLOSED        202
+#define    WINDOW_ICONIFIED     203
+#define    WINDOW_DEICONIFIED   204
+
+gint button_press_callback       ( GtkWidget* widget, GdkEventButton* event, gpointer data);
+gint button_release_callback     ( GtkWidget* widget, GdkEventButton* event, gpointer data);
+gint motion_notify_callback      ( GtkWidget* widget, GdkEventMotion* event, gpointer data);
+gint delete_callback             ( GtkWidget* widget, GdkEventAny* event, gpointer data);
+gint destroy_callback            ( GtkWidget* widget, GdkEventAny* event, gpointer data);
+gint expose_callback             ( GtkWidget* widget, GdkEventExpose* event, gpointer data);
+gint key_press_callback          ( GtkWidget* widget, GdkEventKey* event, gpointer data);
+gint key_release_callback        ( GtkWidget* widget, GdkEventKey* event, gpointer data);
+gint enter_notify_callback       ( GtkWidget* widget, GdkEventCrossing* event, gpointer data);
+gint leave_notify_callback       ( GtkWidget* widget, GdkEventCrossing* event, gpointer data);
+gint configure_callback          ( GtkWidget* widget, GdkEventConfigure* event, gpointer data);
+gint focus_in_callback           ( GtkWidget* widget, GdkEventFocus* event, gpointer data);
+gint focus_out_callback          ( GtkWidget* widget, GdkEventFocus* event, gpointer data);
+gint map_callback                ( GtkWidget* widget, GdkEventAny* event, gpointer data);
+gint unmap_callback              ( GtkWidget* widget, GdkEventAny* event, gpointer data);
+gint visibility_notify_callback  ( GtkWidget* widget, GdkEventVisibility* event, gpointer data);
+gint client_callback             ( GtkWidget* widget, GdkEventClient* client, gpointer data);
+
+gint idle_callback               ( gpointer data);
+void connectSignals              ();
+
 /*******************************************************************************
  * color conversion structures
  */
@@ -97,29 +154,25 @@
   int           width, height;
 } AlphaImage;
 
-#define NO_SHM       0             /* we don't have MIT-Shm support in the X server */
-#define USE_SHM      1             /* we have support, use it */
-#define SUSPEND_SHM  2             /* we have support, but it ran out of space */
-
 typedef struct _Image {
-  Pixmap           pix;            /* pixmap for screen images */
-
-  XImage           *xImg;          /* "real" image */
-  XShmSegmentInfo  *shmiImg;       /* Shm info for shared mem real image */
-
-  XImage           *xMask;         /* mask image for reduced alpha (on/off) images */
-  XShmSegmentInfo  *shmiMask;      /* Shm info for shared mem mask image */
-
-  AlphaImage       *alpha;         /* full alpha channel (for alpha != 0x00 or 0xff) */
+  GdkPixmap      *pix;
+  GdkImage       *xImg;
+  GdkImage       *xMask;
+  AlphaImage     *alpha;         /* alpha channel (for alpha != 0x00 or 0xff) */
+  int            trans;          /* transparent index */
+  int            width, height;  /* we need this in case we are a pixmap */	
+} Image;
 
-  int              trans;          /* transparent index */
-  int              left, top;      /* some GIF movies require drawing offsets */
-  int              width, height;  /* we need this in case we are a pixmap */
 
-  short            latency;        /* between image flips, for "gif-movies" */
-  short            frame;          /* frame number for animations */
-  struct _Image    *next;          /* next movie-frame */
-} Image;
+typedef struct _Widget {
+  GtkWidget     *widget;
+  GdkWindow     *wnd;
+  GtkWidget     *box;
+  GdkCursor     *cursor;
+  GdkFont       *fnt;
+  int           bg;
+  int           fg;
+} Widget;
 
 
 /*******************************************************************************
@@ -142,55 +195,38 @@
  * end up in costly round-trips and even more memory (than we trade for speed here).
  * It's a must have for our popup key/focus event forwarding (see wnd.c)
  */
-
+#if 0
 typedef struct _WindowRec {
   Window         w;
   unsigned       flags;
   Window         owner;
 } WindowRec;
+#endif
 
 /*******************************************************************************
  * this is the master AWT structure (singleton object), glueing it al together
  */
 
 typedef struct _Toolkit {
-  Display        *dsp;
-  Window         root;
+  GtkWindow*      root;
 
   char           *buf;
   unsigned int   nBuf;
 
-  int            colorMode;      /* refers to CM_xx constants, not X visuals */
-  Rgb2True       *tclr;
-  Rgb2Pseudo     *pclr;
-  Rgb2Direct     *dclr;
-
-  int            shm;
-  int            shmThreshold;
-
-  Cursor         cursors[14];
-
-  DecoInset      frameInsets;
-  DecoInset      dialogInsets;
-
-  XEvent         event;
-  char           preFetched;
-  char           blocking;
-  int            pending;
+  JNIEnv         *env;
+  GdkCursor      cursors[14];
+
+  GdkEvent*      event;
   int            evtId;
-  fd_set         rfds;           /* used to select-check availability of X input (pthreads) */
 
-  Window         lastWindow;
+  Widget         *lastWindow;
   int            srcIdx;
-  WindowRec      *windows;
+  Widget         **windows;
   int            nWindows;
 
-  Window         cbdOwner;
-  Window         wakeUp;
+  Widget         *cbdOwner;
 
-  Window         focus;     /* this is the real focus, if it is in our process */
-  Window         focusFwd;  /* this might be a (owned) window we forward the focus to */
-  int            fwdIdx;    /* cached index of the focus forward window */
+  Widget         *newWindow;
 } Toolkit;
 
 
@@ -202,34 +238,32 @@
 Toolkit   XTk;
 Toolkit   *X = &XTk;
 
-Atom WM_PROTOCOLS;
-Atom WM_DELETE_WINDOW;
-Atom WM_TAKE_FOCUS;
-Atom WAKEUP;
-Atom RETRY_FOCUS;
-Atom FORWARD_FOCUS;
-Atom SELECTION_DATA;
-Atom JAVA_OBJECT;
-
 jclass  AWTError;
 JNIEnv  *JniEnv;
 
+GdkAtom WM_PROTOCOLS;
+GdkAtom WM_DELETE_WINDOW;
+GdkAtom WM_TAKE_FOCUS;
+GdkAtom WAKEUP;
+GdkAtom RETRY_FOCUS;
+GdkAtom SELECTION_DATA;
+GdkAtom JAVA_OBJECT;
+
 #else
 
 extern Toolkit* X;
 
-extern Atom WM_PROTOCOLS;
-extern Atom WM_DELETE_WINDOW;
-extern Atom WM_TAKE_FOCUS;
-extern Atom WAKEUP;
-extern Atom RETRY_FOCUS;
-extern Atom FORWARD_FOCUS;
-extern Atom SELECTION_DATA;
-extern Atom JAVA_OBJECT;
-
 extern jclass AWTError;
 extern JNIEnv* JniEnv;
 
+extern GdkAtom WM_PROTOCOLS;
+extern GdkAtom WM_DELETE_WINDOW;
+extern GdkAtom WM_TAKE_FOCUS;
+extern GdkAtom WAKEUP;
+extern GdkAtom RETRY_FOCUS;
+extern GdkAtom SELECTION_DATA;
+extern GdkAtom JAVA_OBJECT;
+
 #endif /* MAIN */
 
 extern long StdEvents, PopupEvents;
@@ -335,143 +369,33 @@
  * color functions & defines
  */
 
-/*
- * These are our directly supported visuals / color modes. Note that there is
- * no more 1-1 correspondence to X visuals, since we do a categorisation with
- * respect to our internal RGB <-> pixel conversion. All visuals not listed
- * explicitly are handled via the generic XAllocColor/XQueryColor (which might
- * slow down images considerably)
- *
- * NOTE: these values have to be != 0, since '0' is used to trigger color init
- */
-#define CM_PSEUDO_256   1  /* PseudoColor visual */
-#define CM_TRUE         2  /* general TrueColor visual */
-#define CM_TRUE_888     3  /* special 8-8-8 bit TrueColor visual */
-#define CM_DIRECT       4
-#define CM_GENERIC      5  /* grays, DirectColor (packed) etc. */
-
 int needsFullAlpha ( Toolkit* X, Image *img, double threshold );
 
 void initColorMapping ( JNIEnv* env, jclass clazz, Toolkit* X);
 jlong Java_java_awt_Toolkit_clrBright ( JNIEnv* env, jclass clazz, jint rgb );
 jlong Java_java_awt_Toolkit_clrDark ( JNIEnv* env, jclass clazz, jint rgb );
 
-#define JRGB(_r,_g,_b)  (_r<<16 | _g<<8 | _b)
-#define JRED(_rgb)      ((_rgb & 0xff0000) >> 16)
-#define JGREEN(_rgb)    ((_rgb & 0x00ff00) >> 8)
-#define JBLUE(_rgb)     (_rgb & 0x0000ff)
-
-#define D8   36.43  /* 255 / 7 */
-#define D16  18.21
-
-#define JI8(_v) (int)((_v + D16) / D8)
-#define XI8(_v) (int)(((_v>>8) + D16) / D8)
-
-#define ROUND_SHORT2CHAR(_n) \
-  ((unsigned short)_n >= 0xff70 ) ? 0xff : (unsigned char)(((unsigned short)_n + 0x80) >> 8)
-
-/* shift ops with negative values have undefined results */
-#define SIGNED_RSHIFT(_var,_val,_shift)   \
-   _var = _val;                           \
-   if ( _shift > 0 )	 _var >>= _shift; \
-   else                  _var <<= -_shift;
-
-#define SIGNED_LSHIFT(_var,_val,_shift)   \
-   _var = _val;                           \
-   if ( _shift > 0 )	 _var <<= _shift; \
-   else                  _var >>= -_shift;
-
-
-static inline jint
-pixelValue ( Toolkit* X, jint rgb )
-{
-  int      r,g,b;
-  XColor   xclr;
-
-  switch ( X->colorMode ) {
-  case CM_PSEUDO_256:
-	return X->pclr->pix [JI8(JRED(rgb))] [JI8(JGREEN(rgb))] [JI8(JBLUE(rgb))];
-
-  case CM_TRUE:
-	SIGNED_RSHIFT( b, (rgb & X->tclr->blueMask), X->tclr->blueShift);
-	SIGNED_RSHIFT( g, (rgb & X->tclr->greenMask), X->tclr->greenShift);
-	SIGNED_RSHIFT( r, (rgb & X->tclr->redMask), X->tclr->redShift);
-	return ( b | g | r );
-
-  case CM_TRUE_888:
-	return (rgb & 0xffffff);
-
-  case CM_DIRECT:
-	return (((jint)X->dclr->redPix[JRED(rgb)]     << X->dclr->redShift) |
-			((jint)X->dclr->greenPix[JGREEN(rgb)] << X->dclr->greenShift) |
-			((jint)X->dclr->bluePix[JBLUE(rgb)]   << X->dclr->blueShift));
-
-  default:
-	/*
-	 * this is a generic fallback for "exotic" visuals and might be *awefully*
-	 * slow (esp. for images) because XAllocColor is a roundtrip
-	 */
-	xclr.red = (rgb & 0xff0000) >> 8;
-	xclr.green = (rgb & 0xff00);
-	xclr.blue = (rgb & 0xff) << 8;
-	xclr.flags = DoRed | DoGreen | DoBlue;
-	XAllocColor( X->dsp, DefaultColormapOfScreen( DefaultScreenOfDisplay( X->dsp)), &xclr);
-	return xclr.pixel;
-  }
+static inline gulong
+pixelValue ( Toolkit* X, guint32 rgb )
+{
+  return gdk_rgb_xpixel_from_rgb( rgb);
 }
 
 static inline void
-rgbValues ( Toolkit* X, unsigned long pixel, int* r, int* g, int* b )
+rgbValues ( Toolkit* X, guint32 pixel, int* r, int* g, int* b )
 {
-  Visual         *v;
-  XColor         xclr;
-
-  switch ( X->colorMode ) {
-  case CM_PSEUDO_256:
-	*r = X->pclr->rgb[(unsigned char)pixel].r;
-	*g = X->pclr->rgb[(unsigned char)pixel].g;
-	*b = X->pclr->rgb[(unsigned char)pixel].b;
-	break;
-
-  case CM_TRUE:
-	v = DefaultVisual( X->dsp, DefaultScreen( X->dsp));
-	SIGNED_LSHIFT( *r, (pixel & v->red_mask), X->tclr->redShift);
-	SIGNED_LSHIFT( *g, (pixel & v->green_mask), X->tclr->greenShift);
-	SIGNED_LSHIFT( *b, (pixel & v->blue_mask), X->tclr->blueShift);
-	*r >>= 16;
-	*g >>= 8;
-	break;
-/*
-	*r = ((pixel & v->red_mask)   << X->tclr->redShift)   >> 16;
-	*g = ((pixel & v->green_mask) << X->tclr->greenShift) >> 8;
-	*b = ((pixel & v->blue_mask)  << X->tclr->blueShift);
-	break;
-*/
-  case CM_TRUE_888:
-	*r = JRED( pixel);
-	*g = JGREEN( pixel);
-	*b = JBLUE( pixel);
-	break;
-
-  case CM_DIRECT:
-	v = DefaultVisual( X->dsp, DefaultScreen( X->dsp));
-	*r = X->dclr->red[   ((pixel & v->red_mask) >> X->dclr->redShift) ];
-	*g = X->dclr->green[ ((pixel & v->green_mask) >> X->dclr->greenShift) ];
-	*b = X->dclr->blue[  ((pixel & v->blue_mask) >> X->dclr->blueShift) ];
-	break;
-
-  default:
-	/*
-	 * this is a generic fallback for "exotic" visuals and might be *awefully*
-	 * slow (esp. for images) because XAllocColor is a roundtrip
-	 */
-	xclr.pixel = pixel;
-	XQueryColor( X->dsp, DefaultColormapOfScreen( DefaultScreenOfDisplay( X->dsp)), &xclr);
-	*r = xclr.red >> 8;
-	*g = xclr.green >> 8;
-	*b = xclr.blue >> 8;
-
-    break;
+  GdkColor *c;
+  GdkColormap* cmap = gdk_rgb_get_cmap();
+  int idx; 
+          
+  for ( idx=0; idx<cmap->size; idx++) {
+    c = &(cmap->colors[idx]);
+    if ( c->pixel == pixel ) {
+      *r = c->red;
+      *g = c->green;
+      *b = c->blue;
+      return;
+    }
   }
 }
 
@@ -480,14 +404,12 @@
  * image functions
  */
 
-int needsFullAlpha(Toolkit*, Image*, double);
-Image* createImage ( int width, int height);
-void createXMaskImage ( Toolkit* X, Image* img );
-void createXImage ( Toolkit* X, Image* img );
-void createAlphaImage ( Toolkit* X, Image* img );
+GdkImage* createXMaskImage ( Toolkit* X, Image* img );
+GdkImage* createXImage ( Toolkit* X, Image* img );
+AlphaImage* createAlphaImage ( Toolkit* X, Image* img );
 void initScaledImage ( Toolkit* X, Image *tgt, Image *src,
-					   int dx0, int dy0, int dx1, int dy1,
-					   int sx0, int sy0, int sx1, int sy1 );
+                       int dx0, int dy0, int dx1, int dy1,
+                       int sx0, int sy0, int sx1, int sy1 );
 void Java_java_awt_Toolkit_imgFreeImage( JNIEnv* env, jclass clazz, Image * img);
 
 
@@ -510,7 +432,7 @@
 jobject selectionClear ( JNIEnv* env, Toolkit* X );
 jobject selectionRequest ( JNIEnv* env, Toolkit* X );
 
-
+#if 0 /* Unused */
 /*****************************************************************************************
  * async (multithreaded) macros
  * this can be used to solve the problem of deferred drawing requests, not being
@@ -565,8 +487,9 @@
 
   return -1;
 }
+#endif /* Unused */
 
-static inline int getSourceIdx ( Toolkit* X, Window w )
+static inline int getSourceIdx ( Toolkit* X, Widget* w )
 {
   int      n;
   register int i;
@@ -577,12 +500,12 @@
   else {
 	for ( i = (unsigned long) w, n=0; n < X->nWindows; i++, n++ ) {
 	  i %= X->nWindows;
-	  if ( X->windows[i].w == w ){
+	  if ( X->windows[i] == w ){
 		X->srcIdx = i;
 		X->lastWindow = w;
 		return X->srcIdx;
 	  }
-	  else if ( X->windows[i].w == 0 ){
+	  else if ( X->windows[i] == 0 ){
 		return -1;
 	  }
 	}
@@ -590,6 +513,28 @@
   }
 }
 
+static inline int getWidgetIdx( GtkWidget* gw, GdkEvent* evt )
+{
+  int      n;
+  Widget   *w;
+  Widget   *we;
+
+  we = gtk_get_event_widget( evt);
+  if ( ( we != NULL) && ( we != gw) )
+    return -1;
+
+  for ( n=0; n < X->nWindows;n++ ) {
+    w = (Widget*)X->windows[n];
+    if ( w && (w->widget == gw) ){
+      X->srcIdx = n;
+      return X->srcIdx;
+    }
+  }
+
+  return -1;
+}
+
+#if 0 /* Unused */
 static inline int checkSource ( Toolkit* X, int idx )
 {
   return ( (idx >= 0) && (idx < X->nWindows) && (X->windows[idx].w) );
@@ -618,5 +563,6 @@
  */
 
 #define	USE_POLLING_AWT	1
+#endif /* Unused */
 
 #endif
diff -urN kaffe-1.1.4/libraries/clib/awt/X/wnd.c kaffe-1.1.4-gtkawt/libraries/clib/awt/X/wnd.c
--- kaffe-1.1.4/libraries/clib/awt/X/wnd.c	2000-01-19 19:04:31.000000000 +0800
+++ kaffe-1.1.4-gtkawt/libraries/clib/awt/X/wnd.c	2004-03-12 21:25:59.000000000 +0800
@@ -4,110 +4,41 @@
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
  *
+ * Copyright (c) 2004
+ * 	Kaffe.org contributors.
+ *
  * See the file "license.terms" for information on usage and redistribution 
  * of this file. 
  */
 
 #include <limits.h>
-#include <X11/Xlib.h>
-#include <X11/cursorfont.h>
-#include <X11/Xutil.h>
+#include <gtk/gtk.h>
+#include <gtk/gtktable.h>
 #include "toolkit.h"
 
-
-long StdEvents = ExposureMask | KeyPressMask | KeyReleaseMask |
-		 PointerMotionMask | /* PointerMotionHintMask | */
-		 ButtonPressMask | ButtonReleaseMask | ButtonMotionMask |
-		 EnterWindowMask | LeaveWindowMask | StructureNotifyMask |
-		 FocusChangeMask | VisibilityChangeMask;
-
-long PopupEvents = ExposureMask |
-		 PointerMotionMask | /* PointerMotionHintMask | */
-		 ButtonPressMask | ButtonReleaseMask | ButtonMotionMask |
-		 EnterWindowMask | LeaveWindowMask | StructureNotifyMask |
-		 VisibilityChangeMask;
-
-/*
- * X dosen't have "owned" popups (menus, choice windows etc.), all it has
- * are 'isTransientFor' properties, and these might not be honored by native
- * window managers in a way that the popup, when getting the focus, doesn't
- * visibly take the focus away from the owner ("shading" its titlebar). The
- * only reliable, non wm-dependent way to prevent this seems to be not to select
- * key events for the popup (i.e. not giving it the focus at all). But we don't
- * want to let this native layer deficiency (of a single platform) show up on
- * the Java side. We implement these temporary popup focus shifts by means of
- * focus forwarding in the native layer, which means we have to take care of
- * propper forwarding/restore during setVisible/requestFocus/destroy, and
- * focus/key events. The owner never gives up the focus with respect to X,
- * but the native layer keeps track of all the involved retargeting of
- * Java events, thus giving Java the illusion of a real focus switch.
- * Since this comes with some "artificial" events we have
- * to process in the Java event queue, we use ClientMessages mapped to the
- * corresponding Java FocusEvents.
- */
-
-/* also used in evt.c */
-void 
-forwardFocus ( int cmd, Window wnd )
-{
-  XEvent event;
-
-  event.xclient.type = ClientMessage; 
-  event.xclient.message_type = FORWARD_FOCUS;
-  event.xclient.format = 32;
-  event.xclient.data.l[0] = cmd;
-  event.xclient.window = wnd;
-	  
-  XSendEvent( X->dsp, wnd, False, StdEvents, &event);
-}
-
-static void 
-retryFocus ( Window wnd, Window owner, int count )
-{
-  XEvent event;
-
-  event.xclient.type = ClientMessage; 
-  event.xclient.message_type = RETRY_FOCUS;
-  event.xclient.format = 32;
-  event.xclient.data.l[0] = count;
-  event.xclient.data.l[1] = owner;
-  event.xclient.window = wnd;
-	  
-  XSendEvent( X->dsp, (Window)wnd, False, StdEvents, &event);
-  XSync( X->dsp, False);
-}
-
-static Cursor
+static GdkCursor* 
 getCursor ( jint jCursor )
 {
-  Cursor cursor;
-
-  if ( jCursor > 13 ) jCursor = 0;
+  GdkCursorType shape;
 
-  if ( !(cursor = X->cursors[jCursor]) ){
-	int shape;
-	switch ( jCursor ) {
-	case  0: shape = XC_top_left_arrow; break;       /*  0: DEFAULT_CURSOR     */
-	case  1: shape = XC_crosshair; break;            /*  1: CROSSHAIR_CURSOR   */
-	case  2: shape = XC_xterm; break;                /*  2: TEXT_CURSOR        */
-	case  3: shape = XC_watch; break;                /*  3: WAIT_CURSOR        */
-	case  4: shape = XC_bottom_left_corner; break;   /*  4: SW_RESIZE_CURSOR   */
-	case  5: shape = XC_bottom_right_corner; break;  /*  5: SE_RESIZE_CURSOR   */
-	case  6: shape = XC_top_left_corner; break;      /*  6: NW_RESIZE_CURSOR   */
-	case  7: shape = XC_top_right_corner; break;     /*  7: NE_RESIZE_CURSOR   */
-	case  8: shape = XC_top_side; break;             /*  8: N_RESIZE_CURSOR    */
-	case  9: shape = XC_bottom_side; break;          /*  9: S_RESIZE_CURSOR    */
-	case 10: shape = XC_left_side; break;            /* 10: W_RESIZE_CURSOR    */
-	case 11: shape = XC_right_side; break;           /* 11: E_RESIZE_CURSOR    */
-	case 12: shape = XC_hand2; break;                /* 12: HAND_CURSOR        */
-	case 13: shape = XC_fleur; break;                /* 13: MOVE_CURSOR        */
-	default: shape = XC_top_left_arrow;
-	}
-
-	cursor = X->cursors[jCursor] = XCreateFontCursor( X->dsp, shape);
+  switch ( jCursor ) {
+    case 0:  shape = GDK_TOP_LEFT_ARROW; break;         /* DEFAULT_CURSOR */
+    case 1:  shape = GDK_CROSSHAIR; break;              /* CROSSHAIR_CURSOR */
+    case 2:  shape = GDK_XTERM; break;                  /* TEXT_CURSOR */
+    case 3:  shape = GDK_WATCH; break;                  /* WAIT_CURSOR */
+    case 4:  shape = GDK_BOTTOM_LEFT_CORNER; break;     /* SW_RESIZE_CURSOR */
+    case 5:  shape = GDK_BOTTOM_RIGHT_CORNER; break;    /* SE_RESIZE_CURSOR */
+    case 6:  shape = GDK_TOP_LEFT_CORNER; break;        /* NW_RESIZE_CURSOR */
+    case 7:  shape = GDK_TOP_RIGHT_CORNER; break;       /* NE_RESIZE_CURSOR */
+    case 8:  shape = GDK_TOP_SIDE; break;               /* N_RESIZE_CURSOR */
+    case 9:  shape = GDK_BOTTOM_SIDE; break;            /* S_RESIZE_CURSOR */
+    case 10: shape = GDK_LEFT_SIDE; break;              /* W_RESIZE_CURSOR */
+    case 11: shape = GDK_RIGHT_SIDE; break;             /* E_RESIZE_CURSOR */
+    case 12: shape = GDK_HAND2; break;                  /* HAND_CURSOR */
+    case 13: shape = GDK_FLEUR; break;                  /* MOVE_CURSOR */
+    default: shape = GDK_TOP_LEFT_ARROW; break;
   }
-
-  return cursor;
+  return gdk_cursor_new( shape);
 }
 
 
@@ -117,10 +48,9 @@
   char *buf;
 
   if ( jTitle ) {
-	buf = java2CString( env, X, jTitle);
-
-	DBG( AWT_WND, printf("setTitle: %p, \"%s\"\n", wnd, buf));
-	XStoreName( X->dsp, (Window)wnd, buf);
+	buf = java2CString( env, X, jTitle);	
+        DBG( AWT_WND, printf("setTitle: \"%s\"\n", buf));
+	gtk_window_set_title( ((Widget*)wnd)->widget, buf);
   }
 }
 
@@ -129,144 +59,91 @@
 Java_java_awt_Toolkit_wndSetResizable ( JNIEnv* env, jclass clazz, void* wnd, jboolean isResizable,
 										int x, int y, int width, int height )
 {
-  XSizeHints hints;
 
-  DBG( AWT_WND, printf("setResizable: %p, %d, %d,%d,%d,%d\n", wnd, isResizable, x,y,width,height));
+  DBG( AWT_WND, printf("setResizable: %d, %d,%d,%d,%d\n", isResizable, x,y,width,height));
+  gtk_window_set_policy( ((Widget*)wnd)->widget, isResizable, isResizable, isResizable);
+}
 
-  if ( !isResizable ) {
-	hints.min_width  = hints.max_width = width;
-	hints.min_height = hints.max_height = height;
-  }
-  else {
-	hints.min_width = hints.min_height = 0;
-	hints.max_width = hints.max_height = INT_MAX;
-  }
+void
+connect_wnd_signals( GtkWidget* wnd ) 
+{
+#define _CONNECT(name, callback) \
+  gtk_signal_connect( GTK_OBJECT(wnd), name, GTK_SIGNAL_FUNC(callback), NULL)
+
+  _CONNECT("button_press_event", button_press_callback);
+  _CONNECT("button_release_event", button_release_callback);
+  _CONNECT("motion_notify_event", motion_notify_callback);
+  _CONNECT("delete_event", delete_callback);
+  _CONNECT("expose_event", expose_callback);
+  _CONNECT("key_press_event", key_press_callback);
+  _CONNECT("key_release_event", key_release_callback);
+  _CONNECT("enter_notify_event", enter_notify_callback);
+  _CONNECT("leave_notify_event", leave_notify_callback);
+  _CONNECT("configure_event", configure_callback);
+  _CONNECT("focus_in_event", focus_in_callback);
+  _CONNECT("focus_out_event", focus_out_callback);
+  _CONNECT("map_event", map_callback);
+  _CONNECT("unmap_event", unmap_callback);
+  _CONNECT("visibility_notify_event", visibility_notify_callback);
+  _CONNECT("client_event", client_callback);
+  _CONNECT("destroy", destroy_callback);
 
-  hints.flags = PMinSize | PMaxSize;
-  XSetWMNormalHints( X->dsp, (Window)wnd, &hints);
+#undef _CONNECT
 }
 
-
-static Window
-createWindow ( JNIEnv* env, jclass clazz, Window parent, Window owner, jstring jTitle,
+static Widget*
+createWindow ( JNIEnv* env, jclass clazz, GtkWindowType type, GdkWindow* parent, void* owner, jstring jTitle,
 			   jint x, jint y, jint width, jint height,
 			   jint jCursor, jint clrBack, jboolean isResizable )
 {
-  unsigned long          valueMask;
-  XSetWindowAttributes   attributes;
-  Window                 wnd;
-  Atom                   protocol[2];
-  int                    i;
-
-  /* note that we don't select on key / focus events for popus (owner, no title) */
-  attributes.event_mask = (owner && !jTitle) ? PopupEvents :  StdEvents;
-  attributes.background_pixel = clrBack;
-  attributes.bit_gravity = ForgetGravity;
-  attributes.cursor = getCursor( jCursor);
-  valueMask = CWEventMask | CWBackPixel | CWBitGravity | CWCursor;
-
-  if ( !jTitle ) {
-	attributes.override_redirect = True;
-	attributes.save_under = True;
-	valueMask |= CWOverrideRedirect | CWSaveUnder;
-  }
-  else {
-	attributes.backing_store = WhenMapped;
-	valueMask |= CWBackingStore;
-  }
-
-  if ( width <= 0 )  width = 1;
-  if ( height <= 0 ) height = 1;
+  Widget *widget = calloc( 1, sizeof( Widget));
 
-  DBG( AWT_WND, printf("XCreateWindow %d,%d,%d,%d\n", x, y, width, height));
-  wnd = XCreateWindow( X->dsp, parent, x, y, width, height, 0,
-					   CopyFromParent, InputOutput, CopyFromParent,
-					   valueMask, &attributes);
-  DBG( AWT_WND, printf(" -> %lx\n", wnd));
-
-  if ( wnd ) {
-	i=0;
-	protocol[i++] = WM_DELETE_WINDOW;
-	protocol[i++] = WM_TAKE_FOCUS;
-	XSetWMProtocols( X->dsp, wnd, protocol, i);
+  widget->widget = gtk_window_new( type);
+  gtk_widget_set_events( widget->widget, GDK_ALL_EVENTS_MASK);
 
-	if ( owner ){
-	  XSetTransientForHint( X->dsp, wnd, owner );
-	}
+  connect_wnd_signals( widget->widget);
 
-	if ( !isResizable )
-	  Java_java_awt_Toolkit_wndSetResizable( env, clazz,
-											 (void*)wnd, isResizable, x, y, width, height);
+  if ( parent )
+    gtk_widget_set_parent_window( widget->widget, parent);
 
-	if ( jTitle )
-	  Java_java_awt_Toolkit_wndSetTitle( env, clazz, (void*)wnd, jTitle);
+  gtk_widget_set_uposition( widget->widget, x, y);
+  gtk_widget_set_usize( widget->widget, width, height);
 
-	return wnd;
-  }
-  else {
-	return 0;
-  }
-}
+  if ( !isResizable )
+    Java_java_awt_Toolkit_wndSetResizable( env, clazz, (void*) widget, isResizable, x, y, width, height );
+  if ( jTitle )
+    Java_java_awt_Toolkit_wndSetTitle( env, clazz, (void*) widget, jTitle );
 
-/*
- * We register here (and not in evt.c, during evtRegisterSource) because
- * we want to be able to store attributes (flags, owner), without being
- * forced to use fancy intermediate cache mechanisms (or intermediate
- * register states). Storing own Window attributes (flags, owners) in the native
- * layer is essential for mechanisms like the popup focus forwarding, but can
- * be used in other places (like inset detection and mapping) as well, to avoid
- * costly round-trips or additional state passed in from the Java side
- */
-static int
-registerSource ( Toolkit* X, Window wnd, Window owner, int flags)
-{
-  int i = getFreeSourceIdx( X, wnd);
+  widget->cursor = getCursor( jCursor);
+  widget->bg = clrBack;
 
-  if ( i >= 0 ) {
-	X->windows[i].w = wnd;
-	X->windows[i].flags = flags;
-	X->windows[i].owner = owner;
-	return i;
-  }
-  else {
-	DBG( AWT_EVT, printf("window table out of space: %d", X->nWindows));
-	return -1;
-  }
+  return widget;
 }
 
-
 void*
 Java_java_awt_Toolkit_wndCreateFrame ( JNIEnv* env, jclass clazz, jstring jTitle,
 									   jint x, jint y, jint width, jint height,
 									   jint jCursor, jint clrBack, jboolean isResizable )
 {
-  Window w = createWindow( env, clazz, DefaultRootWindow( X->dsp), 0, jTitle,
-							   x, y, width, height,
-							   jCursor, clrBack, isResizable);
-  DBG( AWT_WND, printf("createFrame( %p, %d,%d,%d,%d,..) -> %lx\n", jTitle,x,y,width,height, w));
-
-  if ( w )
-	registerSource( X, w, 0, WND_FRAME);
+  GdkWindow* parent = NULL;
+  void* owner = NULL;
 
-  return (void*)w;
+  DBG( AWT_WND, printf("createFrame( %p, %d,%d,%d,%d..)\n", jTitle,x,y,width,height));
+  return (void*) createWindow( env, clazz, GTK_WINDOW_TOPLEVEL, parent, owner, jTitle,
+                               x, y, width, height, jCursor, clrBack, isResizable );
 }
 
-
 void*
 Java_java_awt_Toolkit_wndCreateWindow ( JNIEnv* env, jclass clazz, void* owner,
 										jint x, jint y, jint width, jint height,
 										jint jCursor, jint clrBack )
 {
+  GdkWindow* parent = NULL;
+  
+  DBG( AWT_WND, printf("createWindow( %d,%d,%d,%d..)\n", x,y,width,height));
+  return (void*)createWindow( env, clazz, GTK_WINDOW_POPUP, parent, owner, NULL, x, y,
+                              width, height, jCursor, clrBack, JNI_TRUE);
 
-  Window w = createWindow( env, clazz, X->root, (Window)owner, NULL,
-							   x, y, width, height,
-							   jCursor, clrBack, JNI_TRUE);
-  DBG( AWT_WND, printf("createWindow( %p, %d,%d,%d,%d,..) -> %lx\n", owner,x,y,width,height, w));
-
-  if ( w )
-	registerSource( X, w, (Window)owner, WND_WINDOW);
-
-  return (void*)w;
 }
 
 
@@ -275,54 +152,26 @@
 										jint x, jint y, jint width, jint height,
 										jint jCursor, jint clrBack, jboolean isResizable )
 {
-  Window w = createWindow( env, clazz, DefaultRootWindow( X->dsp), (Window)owner, jTitle,
-							   x, y, width, height,
-							   jCursor, clrBack, isResizable);
-  DBG( AWT_WND, printf("createDialog( %p,%p, %d,%d,%d,%d,..) -> %lx\n", owner,jTitle,x,y,width,height,w));
-
-  if ( w )
-	registerSource( X, w, (Window)owner, WND_DIALOG);
+  GdkWindow* parent = NULL;
 
-  return (void*)w;
+  DBG( AWT_WND, printf("createDialog( %p, %d,%d,%d,%d,..) -> \n", jTitle,x,y,width,height));
+  return (void*) createWindow( env, clazz, GTK_WINDOW_DIALOG, parent, owner, jTitle, x, y,
+                               width, height, jCursor, clrBack, isResizable );
 }
 
 
 void
-Java_java_awt_Toolkit_wndDestroyWindow ( JNIEnv* env, jclass clazz, Window wnd )
+Java_java_awt_Toolkit_wndDestroyWindow ( JNIEnv* env, jclass clazz, void* wnd )
 {
-  int i = getSourceIdx( X, wnd);
-
-  DBG( AWT_WND, printf("destroy window: %lx (%d)\n", wnd, i));
-
-  if ( (i >= 0) && !(X->windows[i].flags & WND_DESTROYED) ) {
-	if ( wnd == X->focusFwd ) {
-	  /*
-	   * reset focus forwading NOW, we can't do it from a clientMessage, since any 
-	   * real focusLost notification would be scrubbed by the subsequent XDestroyWindow
-	   */
-	  resetFocusForwarding( X);
-
-	  if ( X->windows[i].owner && (X->windows[i].owner == X->focus) ) {
-		/*
-		 * This was a explicit dispose(), and the owner still is the real focus window.
-		 * Let's make it think it got back the focus
-		 */
-		forwardFocus( FWD_REVERT, X->windows[i].owner);
-	  }
-	}
-
-	X->windows[i].flags |= WND_DESTROYED;
-	X->windows[i].flags &= ~WND_MAPPED;
-
-	XSync( X->dsp, False); /* maybe we still have pending requests for wnd */
-	XDestroyWindow( X->dsp, wnd);
-  }
+  DBG( AWT_WND, printf("destroy window\n"));
+  gtk_widget_destroy( ((Widget*)wnd)->widget);
 }
 
 
 void
-Java_java_awt_Toolkit_wndRequestFocus ( JNIEnv* env, jclass clazz, Window wnd )
+Java_java_awt_Toolkit_wndRequestFocus ( JNIEnv* env, jclass clazz, void* wnd )
 {
+#if 0
   int     i = getSourceIdx( X, wnd);
 
   DBG( AWT_WND, printf("request focus: %lx (%d)\n", wnd, i));
@@ -365,6 +214,7 @@
 	  XSetInputFocus( X->dsp, (Window)wnd, RevertToParent, CurrentTime);
 	}
   }
+#endif
 }
 
 
@@ -387,22 +237,26 @@
 Java_java_awt_Toolkit_wndSetFrameInsets ( JNIEnv* env, jclass clazz,
 										  jint top, jint left, jint bottom, jint right )
 {
+#if 0	
   X->frameInsets.top  = top;
   X->frameInsets.left = left;
   X->frameInsets.bottom = bottom;
   X->frameInsets.right = right;
   X->frameInsets.guess = 1;
+#endif  
 }
 
 void
 Java_java_awt_Toolkit_wndSetDialogInsets ( JNIEnv* env, jclass clazz,
 										  jint top, jint left, jint bottom, jint right )
 {
+#if 0	
   X->dialogInsets.top  = top;
   X->dialogInsets.left = left;
   X->dialogInsets.bottom = bottom;
   X->dialogInsets.right = right;
   X->dialogInsets.guess = 1;
+#endif  
 }
 
 void
@@ -410,11 +264,10 @@
 									 jint x, jint y, jint width, jint height,
 									 jboolean isResizable )
 {
-  DBG( AWT_WND, printf("setBounds: %lx %d,%d,%d,%d\n", (Window)wnd, x, y, width, height));
+  GdkWindow* w = ((Widget*)wnd)->widget->window;
 
-  if ( width < 0 )  width = 1;
-  if ( height < 0 ) height = 1;
-  XMoveResizeWindow( X->dsp, (Window)wnd, x, y, width, height);
+  DBG( AWT_WND, printf("setBounds: %d,%d,%d,%d\n", x, y, width, height));
+  gdk_window_move_resize( w, x, y, width, height );
 
   /*
    * Our perspective of 'isResizable' is somewhat relaxed: we just disable
@@ -425,18 +278,16 @@
    */
   if ( !isResizable ) {
 	Java_java_awt_Toolkit_wndSetResizable( env, clazz,
-										   (void*)wnd, False, x, y, width, height);
+        (void*)wnd, FALSE, x, y, width, height);
 
   }
 }
 
 void
-Java_java_awt_Toolkit_wndRepaint ( JNIEnv* env, jclass clazz, Window wnd,
+Java_java_awt_Toolkit_wndRepaint ( JNIEnv* env, jclass clazz, void* wnd,
 								   jint x, jint y, jint width, jint height )
 {
-  DBG( AWT_WND, printf("wndRepaint: %lx %d,%d,%d,%d\n", wnd, x, y, width, height));
-
-  XClearArea( X->dsp, wnd, x, y, width, height, True);
+  DBG( AWT_WND, printf("wndRepaint: %d,%d,%d,%d\n", x, y, width, height));
 }
 
 void
@@ -446,39 +297,20 @@
 
 
 void
-Java_java_awt_Toolkit_wndSetVisible ( JNIEnv* env, jclass clazz, Window wnd, jboolean showIt )
+Java_java_awt_Toolkit_wndSetVisible ( JNIEnv* env, jclass clazz, void* wnd, jboolean showIt )
 {
-  int     i = getSourceIdx( X, wnd);
-  Window  owner;
-
-  DBG( AWT_WND, printf("setVisible: %lx (%d) %d\n", wnd, i, showIt));
-
-  if ( (i < 0) || (X->windows[i].flags & WND_DESTROYED) )
-	return;
-
-  owner = X->windows[i].owner;
+  Widget *w = (Widget*) wnd;
+  GdkColor cb;
 
-  if ( showIt ){
-	X->windows[i].flags |= WND_MAPPED;
-	XMapRaised( X->dsp, wnd);
-	XSync( X->dsp, False);
-
-	/*
-	 * Don't automatically forward the focus for owned popups, the standard JDK behavior
-	 * is NOT to set the focus on them unless explicitly requested. It would break
-	 * Swing heavyweight popups (JWindowPopup, both keyboard input and the famous
-	 * "first on Solaris" jitter)
-	 */
-  }
+  DBG( AWT_WND, printf("setVisible: %d\n", showIt));
+  if ( showIt ) {
+    gtk_widget_show(w->widget);
+    w->wnd = w->widget->window;
+    cb.pixel = w->bg;
+    gdk_window_set_background(w->wnd, &cb);
+    gdk_window_set_cursor(w->wnd, w->cursor);                                                               }
   else {
-	if ( wnd == X->focusFwd ) {
-	  forwardFocus( FWD_CLEAR, owner);
-	  forwardFocus( FWD_REVERT, owner);
-	}
-
-	X->windows[i].flags &= ~WND_MAPPED;
-	XUnmapWindow( X->dsp, wnd);
-	XSync( X->dsp, False);
+    gtk_widget_hide(w->widget);
   }
 }
 
@@ -486,22 +318,32 @@
 void
 Java_java_awt_Toolkit_wndToBack ( JNIEnv* env, jclass clazz, void* wnd )
 {
-  DBG( AWT_WND, printf("toBack: %lx\n", (Window)wnd));
-  XLowerWindow( X->dsp, (Window)wnd);
+  GdkWindow* w = ((Widget*)wnd)->widget->window;
+
+  DBG( AWT_WND, printf("toBack\n"));
+  if ( w != NULL )
+    gdk_window_lower(w);
 }
 
 
 void
 Java_java_awt_Toolkit_wndToFront ( JNIEnv* env, jclass clazz, void* wnd )
 {
-  DBG( AWT_WND, printf("toFront: %lx\n", (Window)wnd));
-  XRaiseWindow( X->dsp, (Window)wnd);
+  GdkWindow* w = ((Widget*)wnd)->widget->window;
+  DBG( AWT_WND, printf("toFront\n"));
+  if ( w != NULL )
+    gdk_window_raise(w);
 }
 
 
 void
 Java_java_awt_Toolkit_wndSetCursor ( JNIEnv* env, jclass clazz, void* wnd, jint jCursor )
 {
-  DBG( AWT_WND, printf("setCursor: %lx, %d\n", (Window)wnd, jCursor));
-  XDefineCursor( X->dsp, (Window)wnd, getCursor( jCursor));
+  Widget* w = (Widget*) wnd;
+  GdkWindow* wnd = w->widget->window;
+
+  DBG( AWT_WND, printf("setCursor: %d\n", jCursor));
+  w->cursor = getCursor( jCursor);
+  if ( wnd != NULL )
+    gdk_window_set_cursor( wnd, w->cursor);
 }
